package mgmt_program3;

   import mgmt_memory_map3::*;
   import mgmt_functions_h3::*;
   import alt_xcvr_reconfig_h::*;
   
   task mgmt_program3;
      begin
	 f_sleep(10);

	 
// Write VOD
   	 $display ("Change VOD to 800mv for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // Write logical ch address, 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 0); // Write offset for VOD (which is 0 as offset for vod is 0) at logical_ch_register = address 3
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,8);   // write vod data (8) in data reg (which is at address 4)
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2


	 f_sleep(50);


// Write Preemphasis 0t - pretap
   	 $display ("Change Preemphasis : tx_preemp_0t for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 1); // Write offset for preempahsis pretap (which is 1 as offset for vod is 0) at logical_ch_register = address 3
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,01);   // write pretap data data (01 -- pretap[4:0] = 12 and pretap_inv bit will be "1") in data reg (which is at address 4)
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2

	 f_sleep(50);


// Write posttap2
   	 $display ("Change Preemphasis : tx_preemp_2t for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 3); // Write offset for posttap2 (which is 1 as offset for vod is 0) at logical_ch_register = address 3
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,5'b11001);   // write posttap2 data data (11001 -- posttap2[4:0] = 9 and posttap2_inv bit will be "0") in data reg (which is at address 4)
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2

	 f_sleep(50);



// Write posttap1
   	 $display ("Change Preemphasis : tx_preemp_1t for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 2); // Write offset for posttap1 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,5'b1011);   // write posttap1 data data 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2

	 f_sleep(50);


// Write RX EQDCGAIN
   	 $display ("Change EQ DCGAIN for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 16); // Write offset for eqdcgain
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,3'b011); // write data = 100 i.e. CRAM bits = 1111  
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2

	 f_sleep(50);


	 
	 // read back the VOD data
   	 $display ("Read VOD value for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 0); // Write offset for VOD (which is 0 as offset for vod is 0) at address 3
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(8);
	 f_write_result_bit_to_pio_bit(0, 0); //write result bit 0 to pio bit 0
	 
	 

	 f_sleep(50);

	 // read back the preemphasis data
   	 $display ("Read pretap value for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 1); // Write offset for pretap
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(1);
	 f_write_result_bit_to_pio_bit(0, 1); //write result bit 0 to pio bit 1


	 f_sleep(50);

	 // read back the posttap2 data
   	 $display ("Read posttap2 value for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 3); // Write offset for posttap2 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(5'b11001);
	 f_write_result_bit_to_pio_bit(0, 2); //write result bit 0 to pio bit 2
	 


	 f_sleep(50);

	 // read back the posttap1 data
   	 $display ("Read posttap1 value for logical channel 0\n");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 2); // Write offset for poasttap1 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(4'b1011);
	 f_write_result_bit_to_pio_bit(0, 3); //write result bit 0 to pio bit 3



	 f_sleep(50);

	 // read back the eqdcgain data
   	 $display ("Read EQDCGAIN value for logical channel 0\n");    
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 16); // Write offset for dcgain 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(3'b011);
	 f_write_result_bit_to_pio_bit(0, 4); //write result bit 0 to pio bit 5


// Write RSLB Pre-CDR

   	 $display ("Write preCDRn");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 32); // Write offset for precdr loopback
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,1);   // write loopback data, 1 to enable and 0 to disable
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2


	 f_sleep(50);
	 

// Write RSLB POST-CDR
   	 $display ("Write postCDR");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 33); // Write offset for precdr loopback
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,1);   // write loopback data, 1 to enable and 0 to disable
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2


	 f_sleep(50);


	 // Read pre-CDR
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 32); 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(1);
	 f_write_result_bit_to_pio_bit(0, 5); //write result bit 0 to pio bit 5
	 
	 // Read PostCDR
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 33); 
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 2); // enable rd bit in control register

	 f_sleep(20);
	 f_read_reg(LOCAL_ADDR_XR_ANALOG_DATA);
	 f_compare_result(1);
	 f_write_result_bit_to_pio_bit(0, 6); //write result bit 0 to pio bit 6




   	 $display ("Write preCDRn");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 32); // Write offset for precdr loopback
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,0);   // write loopback data, 1 to enable and 0 to disable
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2


	 f_sleep(50);
	 


   	 $display ("Write postCDR");
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_LCH, 0); // address 0
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_OFFSET, 33); // Write offset for precdr loopback
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_DATA,0);   // write loopback data, 1 to enable and 0 to disable
	 f_write_reg(LOCAL_ADDR_XR_ANALOG_STATUS, 1); // enable wr bit in control register, start write operation by writing 1 in control register = address 2
	 
	 
      end
   endtask // mgmt_program

endpackage // mgmt_program
   
