library verilog;
use verilog.vl_types.all;
entity alt_xcvr_csr_common is
    generic(
        lanes           : integer := 1;
        plls            : integer := 1
    );
    port(
        clk             : in     vl_logic;
        reset           : in     vl_logic;
        address         : in     vl_logic_vector(7 downto 0);
        read            : in     vl_logic;
        readdata        : out    vl_logic_vector(31 downto 0);
        write           : in     vl_logic;
        writedata       : in     vl_logic_vector(31 downto 0);
        pll_locked      : in     vl_logic_vector;
        rx_is_lockedtoref: in     vl_logic_vector;
        rx_is_lockedtodata: in     vl_logic_vector;
        rx_signaldetect : in     vl_logic_vector;
        reset_controller_tx_ready: in     vl_logic;
        reset_controller_rx_ready: in     vl_logic;
        reset_controller_pll_powerdown: in     vl_logic;
        reset_controller_tx_digitalreset: in     vl_logic;
        reset_controller_rx_analogreset: in     vl_logic;
        reset_controller_rx_digitalreset: in     vl_logic;
        csr_reset_tx_digital: out    vl_logic;
        csr_reset_rx_digital: out    vl_logic;
        csr_reset_all   : out    vl_logic;
        csr_pll_powerdown: out    vl_logic;
        csr_tx_digitalreset: out    vl_logic_vector;
        csr_rx_analogreset: out    vl_logic_vector;
        csr_rx_digitalreset: out    vl_logic_vector;
        csr_phy_loopback_serial: out    vl_logic_vector;
        csr_rx_set_locktoref: out    vl_logic_vector;
        csr_rx_set_locktodata: out    vl_logic_vector
    );
end alt_xcvr_csr_common;
