library verilog;
use verilog.vl_types.all;
entity alt_xreconf_cif is
    generic(
        CIF_RECONFIG_ADDR_WIDTH: integer := 3;
        CIF_RECONFIG_DATA_WIDTH: integer := 32;
        CIF_RECONFIG_OFFSET_WIDTH: integer := 5;
        CIF_OFFSET_ADDR_WIDTH: integer := 11;
        CIF_MASTER_ADDR_WIDTH: integer := 3
    );
    port(
        reconfig_clk    : in     vl_logic;
        reset           : in     vl_logic;
        ctrl_go         : in     vl_logic;
        ctrl_opcode     : in     vl_logic_vector(2 downto 0);
        ctrl_lock       : in     vl_logic;
        ctrl_addr_offset: in     vl_logic_vector;
        ctrl_writedata  : in     vl_logic_vector;
        uif_logical_ch_addr: in     vl_logic_vector(9 downto 0);
        ctrl_readdata   : out    vl_logic_vector;
        ctrl_phreaddata : out    vl_logic_vector;
        ctrl_illegal_phy_ch: out    vl_logic;
        ctrl_waitrequest: out    vl_logic;
        reconfig_address_base: out    vl_logic_vector;
        reconfig_writedata_base: out    vl_logic_vector;
        reconfig_write_base: out    vl_logic;
        reconfig_read_base: out    vl_logic;
        reconfig_readdata_base: in     vl_logic_vector;
        reconfig_irq_from_base: in     vl_logic;
        reconfig_waitrequest_from_base: in     vl_logic;
        arb_grant       : in     vl_logic;
        arb_req         : out    vl_logic
    );
end alt_xreconf_cif;
