library verilog;
use verilog.vl_types.all;
entity alt_xreconf_uif is
    generic(
        RECONFIG_USER_ADDR_WIDTH: integer := 3;
        RECONFIG_USER_DATA_WIDTH: integer := 32;
        RECONFIG_USER_OFFSET_WIDTH: integer := 5
    );
    port(
        reconfig_clk    : in     vl_logic;
        reset           : in     vl_logic;
        user_reconfig_address: in     vl_logic_vector;
        user_reconfig_writedata: in     vl_logic_vector;
        user_reconfig_write: in     vl_logic;
        user_reconfig_read: in     vl_logic;
        user_reconfig_readdata: out    vl_logic_vector;
        user_reconfig_waitrequest: out    vl_logic;
        user_reconfig_done: out    vl_logic;
        uif_writedata   : out    vl_logic_vector;
        uif_addr_offset : out    vl_logic_vector;
        uif_mode        : out    vl_logic_vector(2 downto 0);
        uif_logical_ch_addr: out    vl_logic_vector(9 downto 0);
        uif_go          : out    vl_logic;
        uif_readdata    : in     vl_logic_vector;
        uif_phreaddata  : in     vl_logic_vector;
        uif_illegal_pch_error: in     vl_logic;
        uif_illegal_offset_error: in     vl_logic;
        uif_busy        : in     vl_logic
    );
end alt_xreconf_uif;
