library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_8g_tx_pcs_rbc is
    generic(
        prot_mode       : string  := "<auto_single>";
        sup_mode        : string  := "<auto_single>";
        avmm_group_channel_index: integer := 0;
        channel_number  : integer := 0;
        cid_pattern_len : integer := 0;
        use_default_base_address: string  := "true";
        user_base_address: integer := 0;
        test_mode       : string  := "<auto_single>";
        hip_mode        : string  := "<auto_single>";
        pma_dw          : string  := "<auto_single>";
        pcs_bypass      : string  := "<auto_single>";
        phase_compensation_fifo: string  := "<auto_single>";
        tx_compliance_controlled_disparity: string  := "<auto_single>";
        force_kchar     : string  := "<auto_single>";
        force_echar     : string  := "<auto_single>";
        byte_serializer : string  := "<auto_single>";
        data_selection_8b10b_encoder_input: string  := "<auto_single>";
        eightb_tenb_disp_ctrl: string  := "<auto_single>";
        eightb_tenb_encoder: string  := "<auto_single>";
        prbs_gen        : string  := "<auto_single>";
        cid_pattern     : string  := "<auto_single>";
        bist_gen        : string  := "<auto_single>";
        bit_reversal    : string  := "<auto_single>";
        symbol_swap     : string  := "<auto_single>";
        polarity_inversion: string  := "<auto_single>";
        tx_bitslip      : string  := "<auto_single>";
        ctrl_plane_bonding_consumption: string  := "<auto_single>";
        agg_block_sel   : string  := "<auto_single>";
        ctrl_plane_bonding_distribution: string  := "<auto_single>";
        ctrl_plane_bonding_compensation: string  := "<auto_single>";
        bypass_pipeline_reg: string  := "<auto_single>";
        clock_gate_bs_enc: string  := "<auto_single>";
        clock_gate_prbs : string  := "<auto_single>";
        clock_gate_bist : string  := "<auto_single>";
        clock_gate_sw_fifowr: string  := "<auto_single>";
        clock_gate_dw_fifowr: string  := "<auto_single>";
        clock_gate_fiford: string  := "<auto_single>";
        revloop_back_rm : string  := "<auto_single>";
        phfifo_write_clk_sel: string  := "<auto_single>";
        refclk_b_clk_sel: string  := "<auto_single>";
        dynamic_clk_switch: string  := "<auto_single>";
        auto_speed_nego_gen2: string  := "<auto_single>";
        txclk_freerun   : string  := "<auto_single>";
        pcfifo_urst     : string  := "<auto_single>";
        txpcs_urst      : string  := "<auto_single>"
    );
    port(
        aggtxpcsrst     : out    vl_logic;
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmclk         : in     vl_logic;
        avmmread        : in     vl_logic;
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        avmmrstn        : in     vl_logic;
        avmmwrite       : in     vl_logic;
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        bitslipboundaryselect: in     vl_logic_vector(4 downto 0);
        blockselect     : out    vl_logic;
        clkout          : out    vl_logic;
        clkoutgen3      : out    vl_logic;
        clkselgen3      : in     vl_logic;
        coreclk         : in     vl_logic;
        datain          : in     vl_logic_vector(43 downto 0);
        dataout         : out    vl_logic_vector(19 downto 0);
        detectrxloopin  : in     vl_logic;
        detectrxloopout : out    vl_logic;
        dispcbyte       : in     vl_logic;
        dynclkswitchn   : out    vl_logic;
        elecidleinfersel: in     vl_logic_vector(2 downto 0);
        enrevparallellpbk: in     vl_logic;
        fifoselectinchnldown: in     vl_logic_vector(1 downto 0);
        fifoselectinchnlup: in     vl_logic_vector(1 downto 0);
        fifoselectoutchnldown: out    vl_logic_vector(1 downto 0);
        fifoselectoutchnlup: out    vl_logic_vector(1 downto 0);
        grayelecidleinferselout: out    vl_logic_vector(2 downto 0);
        hrdrst          : in     vl_logic;
        invpol          : in     vl_logic;
        observablebyteserdesclock: out    vl_logic;
        parallelfdbkout : out    vl_logic_vector(19 downto 0);
        phfifooverflow  : out    vl_logic;
        phfiforddisable : in     vl_logic;
        phfiforeset     : in     vl_logic;
        phfifotxdeemph  : out    vl_logic;
        phfifotxmargin  : out    vl_logic_vector(2 downto 0);
        phfifotxswing   : out    vl_logic;
        phfifounderflow : out    vl_logic;
        phfifowrenable  : in     vl_logic;
        pipeenrevparallellpbkin: in     vl_logic;
        pipeenrevparallellpbkout: out    vl_logic;
        pipepowerdownout: out    vl_logic_vector(1 downto 0);
        pipetxdeemph    : in     vl_logic;
        pipetxmargin    : in     vl_logic_vector(2 downto 0);
        pipetxswing     : in     vl_logic;
        polinvrxin      : in     vl_logic;
        polinvrxout     : out    vl_logic;
        powerdn         : in     vl_logic_vector(1 downto 0);
        prbscidenable   : in     vl_logic;
        rateswitch      : in     vl_logic;
        rdenableinchnldown: in     vl_logic;
        rdenableinchnlup: in     vl_logic;
        rdenableoutchnldown: out    vl_logic;
        rdenableoutchnlup: out    vl_logic;
        rdenablesync    : out    vl_logic;
        refclkb         : out    vl_logic;
        refclkbreset    : out    vl_logic;
        refclkdig       : in     vl_logic;
        resetpcptrs     : in     vl_logic;
        resetpcptrsinchnldown: in     vl_logic;
        resetpcptrsinchnlup: in     vl_logic;
        revparallellpbkdata: in     vl_logic_vector(19 downto 0);
        rxpolarityin    : in     vl_logic;
        rxpolarityout   : out    vl_logic;
        scanmode        : in     vl_logic;
        syncdatain      : out    vl_logic;
        txblkstart      : in     vl_logic_vector(3 downto 0);
        txblkstartout   : out    vl_logic_vector(3 downto 0);
        txcomplianceout : out    vl_logic;
        txctrlplanetestbus: out    vl_logic_vector(19 downto 0);
        txdatakouttogen3: out    vl_logic_vector(3 downto 0);
        txdataouttogen3 : out    vl_logic_vector(31 downto 0);
        txdatavalid     : in     vl_logic_vector(3 downto 0);
        txdatavalidouttogen3: out    vl_logic_vector(3 downto 0);
        txdivsync       : out    vl_logic_vector(1 downto 0);
        txdivsyncinchnldown: in     vl_logic_vector(1 downto 0);
        txdivsyncinchnlup: in     vl_logic_vector(1 downto 0);
        txdivsyncoutchnldown: out    vl_logic_vector(1 downto 0);
        txdivsyncoutchnlup: out    vl_logic_vector(1 downto 0);
        txelecidleout   : out    vl_logic;
        txpcsreset      : in     vl_logic;
        txpipeclk       : out    vl_logic;
        txpipeelectidle : out    vl_logic;
        txpipesoftreset : out    vl_logic;
        txpmalocalclk   : in     vl_logic;
        txsynchdr       : in     vl_logic_vector(1 downto 0);
        txsynchdrout    : out    vl_logic_vector(1 downto 0);
        txtestbus       : out    vl_logic_vector(19 downto 0);
        wrenableinchnldown: in     vl_logic;
        wrenableinchnlup: in     vl_logic;
        wrenableoutchnldown: out    vl_logic;
        wrenableoutchnlup: out    vl_logic;
        xgmctrl         : in     vl_logic;
        xgmctrlenable   : out    vl_logic;
        xgmctrltoporbottom: in     vl_logic;
        xgmdatain       : in     vl_logic_vector(7 downto 0);
        xgmdataintoporbottom: in     vl_logic_vector(7 downto 0);
        xgmdataout      : out    vl_logic_vector(7 downto 0)
    );
end stratixv_hssi_8g_tx_pcs_rbc;
