library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_common_pcs_pma_interface_rbc is
    generic(
        func_mode       : string  := "<auto_single>";
        prot_mode       : string  := "<auto_single>";
        sup_mode        : string  := "<auto_single>";
        avmm_group_channel_index: integer := 0;
        pcie_gen3_cap   : string  := "non_pcie_gen3_cap";
        pma_if_dft_en   : string  := "dft_dis";
        pma_if_dft_val  : string  := "dft_0";
        refclk_dig_sel  : string  := "refclk_dig_dis";
        use_default_base_address: string  := "true";
        user_base_address: integer := 0;
        pipe_if_g3pcs   : string  := "<auto_single>";
        selectpcs       : string  := "<auto_single>";
        force_freqdet   : string  := "<auto_single>";
        ppmsel          : string  := "<auto_single>";
        auto_speed_ena  : string  := "<auto_single>";
        ppm_cnt_rst     : string  := "<auto_single>";
        ppm_gen1_2_cnt  : string  := "<auto_single>";
        ppm_post_eidle_delay: string  := "<auto_single>";
        ppm_deassert_early: string  := "<auto_single>"
    );
    port(
        aggaligndetsync : out    vl_logic_vector(1 downto 0);
        aggalignstatus  : in     vl_logic;
        aggalignstatussync: out    vl_logic;
        aggalignstatussync0: in     vl_logic;
        aggalignstatussync0toporbot: in     vl_logic;
        aggalignstatustoporbot: in     vl_logic;
        aggcgcomprddall : in     vl_logic;
        aggcgcomprddalltoporbot: in     vl_logic;
        aggcgcomprddout : out    vl_logic_vector(1 downto 0);
        aggcgcompwrall  : in     vl_logic;
        aggcgcompwralltoporbot: in     vl_logic;
        aggcgcompwrout  : out    vl_logic_vector(1 downto 0);
        aggdecctl       : out    vl_logic;
        aggdecdata      : out    vl_logic_vector(7 downto 0);
        aggdecdatavalid : out    vl_logic;
        aggdelcondmet0  : in     vl_logic;
        aggdelcondmet0toporbot: in     vl_logic;
        aggdelcondmetout: out    vl_logic;
        aggendskwqd     : in     vl_logic;
        aggendskwqdtoporbot: in     vl_logic;
        aggendskwrdptrs : in     vl_logic;
        aggendskwrdptrstoporbot: in     vl_logic;
        aggfifoovr0     : in     vl_logic;
        aggfifoovr0toporbot: in     vl_logic;
        aggfifoovrout   : out    vl_logic;
        aggfifordincomp0: in     vl_logic;
        aggfifordincomp0toporbot: in     vl_logic;
        aggfifordoutcomp: out    vl_logic;
        aggfiforstrdqd  : in     vl_logic;
        aggfiforstrdqdtoporbot: in     vl_logic;
        agginsertincomplete0: in     vl_logic;
        agginsertincomplete0toporbot: in     vl_logic;
        agginsertincompleteout: out    vl_logic;
        agglatencycomp0 : in     vl_logic;
        agglatencycomp0toporbot: in     vl_logic;
        agglatencycompout: out    vl_logic;
        aggrcvdclkagg   : in     vl_logic;
        aggrcvdclkaggtoporbot: in     vl_logic;
        aggrdalign      : out    vl_logic_vector(1 downto 0);
        aggrdenablesync : out    vl_logic;
        aggrefclkdig    : out    vl_logic;
        aggrunningdisp  : out    vl_logic_vector(1 downto 0);
        aggrxcontrolrs  : in     vl_logic;
        aggrxcontrolrstoporbot: in     vl_logic;
        aggrxdatars     : in     vl_logic_vector(7 downto 0);
        aggrxdatarstoporbot: in     vl_logic_vector(7 downto 0);
        aggrxpcsrst     : out    vl_logic;
        aggscanmoden    : out    vl_logic;
        aggscanshiftn   : out    vl_logic;
        aggsyncstatus   : out    vl_logic;
        aggtestbus      : in     vl_logic_vector(15 downto 0);
        aggtestsotopldin: in     vl_logic;
        aggtestsotopldout: out    vl_logic;
        aggtxctltc      : out    vl_logic;
        aggtxctlts      : in     vl_logic;
        aggtxctltstoporbot: in     vl_logic;
        aggtxdatatc     : out    vl_logic_vector(7 downto 0);
        aggtxdatats     : in     vl_logic_vector(7 downto 0);
        aggtxdatatstoporbot: in     vl_logic_vector(7 downto 0);
        aggtxpcsrst     : out    vl_logic;
        asynchdatain    : out    vl_logic;
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmclk         : in     vl_logic;
        avmmread        : in     vl_logic;
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        avmmrstn        : in     vl_logic;
        avmmwrite       : in     vl_logic;
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic;
        clklow          : in     vl_logic;
        fref            : in     vl_logic;
        freqlock        : out    vl_logic;
        hardreset       : in     vl_logic;
        pcs8gearlyeios  : in     vl_logic;
        pcs8geidleexit  : in     vl_logic;
        pcs8ggen2ngen1  : out    vl_logic;
        pcs8gltrpma     : in     vl_logic;
        pcs8gpcieswitch : in     vl_logic;
        pcs8gpmacurrentcoeff: in     vl_logic_vector(17 downto 0);
        pcs8gpmarxfound : out    vl_logic;
        pcs8gpowerstatetransitiondone: out    vl_logic;
        pcs8grxdetectvalid: out    vl_logic;
        pcs8gtxdetectrx : in     vl_logic;
        pcs8gtxelecidle : in     vl_logic;
        pcsaggaligndetsync: in     vl_logic_vector(1 downto 0);
        pcsaggalignstatus: out    vl_logic;
        pcsaggalignstatussync: in     vl_logic;
        pcsaggalignstatussync0: out    vl_logic;
        pcsaggalignstatussync0toporbot: out    vl_logic;
        pcsaggalignstatustoporbot: out    vl_logic;
        pcsaggcgcomprddall: out    vl_logic;
        pcsaggcgcomprddalltoporbot: out    vl_logic;
        pcsaggcgcomprddout: in     vl_logic_vector(1 downto 0);
        pcsaggcgcompwrall: out    vl_logic;
        pcsaggcgcompwralltoporbot: out    vl_logic;
        pcsaggcgcompwrout: in     vl_logic_vector(1 downto 0);
        pcsaggdecctl    : in     vl_logic;
        pcsaggdecdata   : in     vl_logic_vector(7 downto 0);
        pcsaggdecdatavalid: in     vl_logic;
        pcsaggdelcondmet0: out    vl_logic;
        pcsaggdelcondmet0toporbot: out    vl_logic;
        pcsaggdelcondmetout: in     vl_logic;
        pcsaggendskwqd  : out    vl_logic;
        pcsaggendskwqdtoporbot: out    vl_logic;
        pcsaggendskwrdptrs: out    vl_logic;
        pcsaggendskwrdptrstoporbot: out    vl_logic;
        pcsaggfifoovr0  : out    vl_logic;
        pcsaggfifoovr0toporbot: out    vl_logic;
        pcsaggfifoovrout: in     vl_logic;
        pcsaggfifordincomp0: out    vl_logic;
        pcsaggfifordincomp0toporbot: out    vl_logic;
        pcsaggfifordoutcomp: in     vl_logic;
        pcsaggfiforstrdqd: out    vl_logic;
        pcsaggfiforstrdqdtoporbot: out    vl_logic;
        pcsagginsertincomplete0: out    vl_logic;
        pcsagginsertincomplete0toporbot: out    vl_logic;
        pcsagginsertincompleteout: in     vl_logic;
        pcsagglatencycomp0: out    vl_logic;
        pcsagglatencycomp0toporbot: out    vl_logic;
        pcsagglatencycompout: in     vl_logic;
        pcsaggrcvdclkagg: out    vl_logic;
        pcsaggrcvdclkaggtoporbot: out    vl_logic;
        pcsaggrdalign   : in     vl_logic_vector(1 downto 0);
        pcsaggrdenablesync: in     vl_logic;
        pcsaggrefclkdig : in     vl_logic;
        pcsaggrunningdisp: in     vl_logic_vector(1 downto 0);
        pcsaggrxcontrolrs: out    vl_logic;
        pcsaggrxcontrolrstoporbot: out    vl_logic;
        pcsaggrxdatars  : out    vl_logic_vector(7 downto 0);
        pcsaggrxdatarstoporbot: out    vl_logic_vector(7 downto 0);
        pcsaggrxpcsrst  : in     vl_logic;
        pcsaggscanmoden : in     vl_logic;
        pcsaggscanshiftn: in     vl_logic;
        pcsaggsyncstatus: in     vl_logic;
        pcsaggtestbus   : out    vl_logic_vector(15 downto 0);
        pcsaggtxctltc   : in     vl_logic;
        pcsaggtxctlts   : out    vl_logic;
        pcsaggtxctltstoporbot: out    vl_logic;
        pcsaggtxdatatc  : in     vl_logic_vector(7 downto 0);
        pcsaggtxdatats  : out    vl_logic_vector(7 downto 0);
        pcsaggtxdatatstoporbot: out    vl_logic_vector(7 downto 0);
        pcsaggtxpcsrst  : in     vl_logic;
        pcsgen3gen3datasel: in     vl_logic;
        pcsgen3pllfixedclk: out    vl_logic;
        pcsgen3pmacurrentcoeff: in     vl_logic_vector(17 downto 0);
        pcsgen3pmacurrentrxpreset: in     vl_logic_vector(2 downto 0);
        pcsgen3pmaearlyeios: in     vl_logic;
        pcsgen3pmaltr   : in     vl_logic;
        pcsgen3pmapcieswdone: out    vl_logic_vector(1 downto 0);
        pcsgen3pmapcieswitch: in     vl_logic_vector(1 downto 0);
        pcsgen3pmarxdetectvalid: out    vl_logic;
        pcsgen3pmarxfound: out    vl_logic;
        pcsgen3pmatxdetectrx: in     vl_logic;
        pcsgen3pmatxelecidle: in     vl_logic;
        pcsgen3ppmeidleexit: in     vl_logic;
        pcsrefclkdig    : in     vl_logic;
        pcsscanmoden    : in     vl_logic;
        pcsscanshiftn   : in     vl_logic;
        pldhclkout      : out    vl_logic;
        pldlccmurstb    : in     vl_logic;
        pldnfrzdrv      : in     vl_logic;
        pldpartialreconfig: in     vl_logic;
        pldtestsitoaggin: in     vl_logic;
        pldtestsitoaggout: out    vl_logic;
        pmaclklowout    : out    vl_logic;
        pmacurrentcoeff : out    vl_logic_vector(17 downto 0);
        pmacurrentrxpreset: out    vl_logic_vector(2 downto 0);
        pmaearlyeios    : out    vl_logic;
        pmafrefout      : out    vl_logic;
        pmahclk         : in     vl_logic;
        pmaiftestbus    : out    vl_logic_vector(9 downto 0);
        pmalccmurstb    : out    vl_logic;
        pmaltr          : out    vl_logic;
        pmanfrzdrv      : out    vl_logic;
        pmaoffcaldone   : out    vl_logic;
        pmaoffcalenin   : in     vl_logic;
        pmapartialreconfig: out    vl_logic;
        pmapcieswdone   : in     vl_logic_vector(1 downto 0);
        pmapcieswitch   : out    vl_logic_vector(1 downto 0);
        pmarxdetectvalid: in     vl_logic;
        pmarxfound      : in     vl_logic;
        pmarxpmarstb    : in     vl_logic;
        pmatxdetectrx   : out    vl_logic;
        pmatxelecidle   : out    vl_logic;
        resetppmcntrs   : in     vl_logic
    );
end stratixv_hssi_common_pcs_pma_interface_rbc;
