library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_pipe_gen3_rbc is
    generic(
        sup_mode        : string  := "<auto_single>";
        avmm_group_channel_index: integer := 0;
        data_mask_count : string  := "data_mask_count";
        data_mask_count_val: integer := 0;
        elecidle_delay_g3: string  := "elecidle_delay_g3";
        elecidle_delay_g3_data: integer := 0;
        pc_en_counter   : string  := "pc_en_count";
        pc_en_counter_data: integer := 0;
        pc_rst_counter  : string  := "pc_rst_count";
        pc_rst_counter_data: integer := 0;
        phfifo_flush_wait: string  := "phfifo_flush_wait";
        phfifo_flush_wait_data: integer := 0;
        phy_status_delay_g12: string  := "phy_status_delay_g12";
        phy_status_delay_g12_data: integer := 0;
        phy_status_delay_g3: string  := "phy_status_delay_g3";
        phy_status_delay_g3_data: integer := 0;
        pma_done_counter: string  := "pma_done_count";
        pma_done_counter_data: integer := 0;
        sigdet_wait_counter: string  := "sigdet_wait_counter";
        sigdet_wait_counter_data: integer := 0;
        use_default_base_address: string  := "true";
        user_base_address: integer := 0;
        wait_clk_on_off_timer: string  := "wait_clk_on_off_timer";
        wait_clk_on_off_timer_data: integer := 4;
        wait_pipe_synchronizing: string  := "wait_pipe_sync";
        wait_pipe_synchronizing_data: integer := 23;
        wait_send_syncp_fbkp: string  := "wait_send_syncp_fbkp";
        wait_send_syncp_fbkp_data: integer := 250;
        mode            : string  := "<auto_single>";
        pipe_clk_sel    : string  := "<auto_single>";
        rate_match_pad_insertion: string  := "<auto_single>";
        ind_error_reporting: string  := "<auto_single>";
        phystatus_rst_toggle_g12: string  := "<auto_single>";
        phystatus_rst_toggle_g3: string  := "<auto_single>";
        cdr_control     : string  := "<auto_single>";
        cid_enable      : string  := "<auto_single>";
        parity_chk_ts1  : string  := "<auto_single>";
        test_mode_timers: string  := "<auto_single>";
        inf_ei_enable   : string  := "<auto_single>";
        spd_chnge_g2_sel: string  := "<auto_single>";
        ctrl_plane_bonding: string  := "<auto_single>";
        cp_dwn_mstr     : string  := "<auto_single>";
        cp_cons_sel     : string  := "<auto_single>";
        cp_up_mstr      : string  := "<auto_single>";
        ph_fifo_reg_mode: string  := "<auto_single>";
        rxvalid_mask    : string  := "<auto_single>";
        asn_clk_enable  : string  := "<auto_single>";
        asn_enable      : string  := "<auto_single>";
        free_run_clk_enable: string  := "<auto_single>";
        bypass_send_syncp_fbkp: string  := "<auto_single>";
        test_out_sel    : string  := "<auto_single>";
        bypass_pma_sw_done: string  := "<auto_single>"
    );
    port(
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmclk         : in     vl_logic;
        avmmread        : in     vl_logic;
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        avmmrstn        : in     vl_logic;
        avmmwrite       : in     vl_logic;
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        blkalgndint     : in     vl_logic;
        blockselect     : out    vl_logic;
        bundlingindown  : in     vl_logic_vector(10 downto 0);
        bundlinginup    : in     vl_logic_vector(10 downto 0);
        bundlingoutdown : out    vl_logic_vector(10 downto 0);
        bundlingoutup   : out    vl_logic_vector(10 downto 0);
        clkcompdeleteint: in     vl_logic;
        clkcompinsertint: in     vl_logic;
        clkcompoverflint: in     vl_logic;
        clkcompundflint : in     vl_logic;
        currentcoeff    : in     vl_logic_vector(17 downto 0);
        currentrxpreset : in     vl_logic_vector(2 downto 0);
        dispcbyte       : out    vl_logic;
        eidetint        : in     vl_logic;
        eidleinfersel   : in     vl_logic_vector(2 downto 0);
        eipartialdetint : in     vl_logic;
        errdecodeint    : in     vl_logic;
        errencodeint    : in     vl_logic;
        gen3clksel      : out    vl_logic;
        gen3datasel     : out    vl_logic;
        hardresetn      : in     vl_logic;
        idetint         : in     vl_logic;
        inferredrxvalidint: out    vl_logic;
        masktxpll       : out    vl_logic;
        pcsrst          : out    vl_logic;
        phystatus       : out    vl_logic;
        pldltr          : in     vl_logic;
        pllfixedclk     : in     vl_logic;
        pmacurrentcoeff : out    vl_logic_vector(17 downto 0);
        pmacurrentrxpreset: out    vl_logic_vector(2 downto 0);
        pmaearlyeios    : out    vl_logic;
        pmaltr          : out    vl_logic;
        pmapcieswdone   : in     vl_logic_vector(1 downto 0);
        pmapcieswitch   : out    vl_logic_vector(1 downto 0);
        pmarxdetectvalid: in     vl_logic;
        pmarxdetpd      : out    vl_logic;
        pmarxfound      : in     vl_logic;
        pmasignaldet    : in     vl_logic;
        pmatxdeemph     : out    vl_logic;
        pmatxdetectrx   : out    vl_logic;
        pmatxelecidle   : out    vl_logic;
        pmatxmargin     : out    vl_logic_vector(2 downto 0);
        pmatxswing      : out    vl_logic;
        powerdown       : in     vl_logic_vector(1 downto 0);
        ppmcntrst8gpcsout: out    vl_logic;
        ppmeidleexit    : out    vl_logic;
        rate            : in     vl_logic_vector(1 downto 0);
        rcvdclk         : in     vl_logic;
        rcvlfsrchkint   : in     vl_logic;
        resetpcprts     : out    vl_logic;
        revlpbk8gpcsout : out    vl_logic;
        revlpbkint      : out    vl_logic;
        rrxdigclksel    : in     vl_logic;
        rrxgen3capen    : in     vl_logic;
        rtxdigclksel    : in     vl_logic;
        rtxgen3capen    : in     vl_logic;
        rxblkstart      : out    vl_logic_vector(3 downto 0);
        rxblkstartint   : in     vl_logic;
        rxd8gpcsin      : in     vl_logic_vector(63 downto 0);
        rxd8gpcsout     : out    vl_logic_vector(63 downto 0);
        rxdataint       : in     vl_logic_vector(31 downto 0);
        rxdatakint      : in     vl_logic_vector(3 downto 0);
        rxdataskip      : out    vl_logic_vector(3 downto 0);
        rxdataskipint   : in     vl_logic;
        rxelecidle      : out    vl_logic;
        rxelecidle8gpcsin: in     vl_logic;
        rxpolarity      : in     vl_logic;
        rxpolarity8gpcsout: out    vl_logic;
        rxpolarityint   : out    vl_logic;
        rxrstn          : in     vl_logic;
        rxstatus        : out    vl_logic_vector(2 downto 0);
        rxsynchdr       : out    vl_logic_vector(1 downto 0);
        rxsynchdrint    : in     vl_logic_vector(1 downto 0);
        rxtestout       : in     vl_logic_vector(19 downto 0);
        rxupdatefc      : in     vl_logic;
        rxvalid         : out    vl_logic;
        scanmoden       : in     vl_logic;
        shutdownclk     : out    vl_logic;
        speedchangeg2   : in     vl_logic;
        testinfei       : out    vl_logic_vector(18 downto 0);
        testout         : out    vl_logic_vector(19 downto 0);
        txblkstart      : in     vl_logic;
        txblkstartint   : out    vl_logic;
        txcompliance    : in     vl_logic;
        txdata          : in     vl_logic_vector(31 downto 0);
        txdataint       : out    vl_logic_vector(31 downto 0);
        txdatak         : in     vl_logic_vector(3 downto 0);
        txdatakint      : out    vl_logic_vector(3 downto 0);
        txdataskip      : in     vl_logic;
        txdataskipint   : out    vl_logic;
        txdeemph        : in     vl_logic;
        txdetectrxloopback: in     vl_logic;
        txelecidle      : in     vl_logic;
        txmargin        : in     vl_logic_vector(2 downto 0);
        txpmaclk        : in     vl_logic;
        txpmasyncp      : out    vl_logic;
        txpmasyncphip   : in     vl_logic;
        txrstn          : in     vl_logic;
        txswing         : in     vl_logic;
        txsynchdr       : in     vl_logic_vector(1 downto 0);
        txsynchdrint    : out    vl_logic_vector(1 downto 0)
    );
end stratixv_hssi_pipe_gen3_rbc;
