library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_rx_pcs_pma_interface_rbc is
    generic(
        prot_mode       : string  := "<auto_single>";
        avmm_group_channel_index: integer := 0;
        selectpcs       : string  := "eight_g_pcs";
        use_default_base_address: string  := "true";
        user_base_address: integer := 0;
        clkslip_sel     : string  := "<auto_single>"
    );
    port(
        asynchdatain    : out    vl_logic;
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmclk         : in     vl_logic;
        avmmread        : in     vl_logic;
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        avmmrstn        : in     vl_logic;
        avmmwrite       : in     vl_logic;
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic;
        clkoutto10gpcs  : out    vl_logic;
        clockinfrompma  : in     vl_logic;
        clockoutto8gpcs : out    vl_logic;
        clockouttogen3pcs: out    vl_logic;
        datainfrompma   : in     vl_logic_vector(79 downto 0);
        dataoutto10gpcs : out    vl_logic_vector(79 downto 0);
        dataoutto8gpcs  : out    vl_logic_vector(19 downto 0);
        dataouttogen3pcs: out    vl_logic_vector(31 downto 0);
        pcs10gclkdiv33txorrx: out    vl_logic;
        pcs10grxclkiqout: in     vl_logic;
        pcs10gsignalok  : out    vl_logic;
        pcs8grxclkiqout : in     vl_logic;
        pcs8grxclkslip  : in     vl_logic;
        pcs8gsigdetni   : out    vl_logic;
        pcsemsiprxclkiqout: in     vl_logic;
        pcsgen3eyemonitorin: out    vl_logic_vector(1 downto 0);
        pcsgen3eyemonitorout: in     vl_logic_vector(7 downto 0);
        pcsgen3pmasignaldet: out    vl_logic;
        pldrxclkslip    : in     vl_logic;
        pldrxpmarstb    : in     vl_logic;
        pmaclkdiv33txorrxin: in     vl_logic;
        pmaclkdiv33txorrxout: out    vl_logic;
        pmaeyemonitorin : in     vl_logic_vector(1 downto 0);
        pmaeyemonitorout: out    vl_logic_vector(7 downto 0);
        pmareservedin   : in     vl_logic_vector(4 downto 0);
        pmareservedout  : out    vl_logic_vector(4 downto 0);
        pmarxclkout     : out    vl_logic;
        pmarxclkslip    : out    vl_logic;
        pmarxpllphaselockin: in     vl_logic;
        pmarxpllphaselockout: out    vl_logic;
        pmarxpmarstb    : out    vl_logic;
        pmasigdet       : in     vl_logic;
        pmasignalok     : in     vl_logic;
        reset           : out    vl_logic
    );
end stratixv_hssi_rx_pcs_pma_interface_rbc;
