library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_tx_pld_pcs_interface_rbc is
    generic(
        avmm_group_channel_index: integer := 0;
        data_source     : string  := "pld";
        is_10g_0ppm     : string  := "false";
        is_8g_0ppm      : string  := "false";
        use_default_base_address: string  := "true";
        user_base_address: integer := 0
    );
    port(
        asynchdatain    : out    vl_logic;
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmclk         : in     vl_logic;
        avmmread        : in     vl_logic;
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        avmmrstn        : in     vl_logic;
        avmmwrite       : in     vl_logic;
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic;
        clockinfrom10gpcs: in     vl_logic;
        clockinfrom8gpcs: in     vl_logic;
        datainfrompld   : in     vl_logic_vector(63 downto 0);
        dataoutto10gpcs : out    vl_logic_vector(63 downto 0);
        dataoutto8gpcs  : out    vl_logic_vector(43 downto 0);
        emsipenablediocsrrdydly: in     vl_logic;
        emsippcstxclkin : in     vl_logic_vector(2 downto 0);
        emsippcstxclkout: out    vl_logic_vector(2 downto 0);
        emsiptxin       : in     vl_logic_vector(103 downto 0);
        emsiptxout      : out    vl_logic_vector(11 downto 0);
        emsiptxspecialin: in     vl_logic_vector(12 downto 0);
        emsiptxspecialout: out    vl_logic_vector(15 downto 0);
        pcs10gtxbitslip : out    vl_logic_vector(6 downto 0);
        pcs10gtxbursten : out    vl_logic;
        pcs10gtxburstenexe: in     vl_logic;
        pcs10gtxcontrol : out    vl_logic_vector(8 downto 0);
        pcs10gtxdatavalid: out    vl_logic;
        pcs10gtxdiagstatus: out    vl_logic_vector(1 downto 0);
        pcs10gtxempty   : in     vl_logic;
        pcs10gtxfifodel : in     vl_logic;
        pcs10gtxfifoinsert: in     vl_logic;
        pcs10gtxframe   : in     vl_logic;
        pcs10gtxfull    : in     vl_logic;
        pcs10gtxpempty  : in     vl_logic;
        pcs10gtxpfull   : in     vl_logic;
        pcs10gtxpldclk  : out    vl_logic;
        pcs10gtxpldrstn : out    vl_logic;
        pcs10gtxwordslip: out    vl_logic;
        pcs10gtxwordslipexe: in     vl_logic;
        pcs8gemptytx    : in     vl_logic;
        pcs8gfulltx     : in     vl_logic;
        pcs8gphfifoursttx: out    vl_logic;
        pcs8gpldtxclk   : out    vl_logic;
        pcs8gpolinvtx   : out    vl_logic;
        pcs8grddisabletx: out    vl_logic;
        pcs8grevloopbk  : out    vl_logic;
        pcs8gtxblkstart : out    vl_logic_vector(3 downto 0);
        pcs8gtxboundarysel: out    vl_logic_vector(4 downto 0);
        pcs8gtxdatavalid: out    vl_logic_vector(3 downto 0);
        pcs8gtxsynchdr  : out    vl_logic_vector(1 downto 0);
        pcs8gtxurstpcs  : out    vl_logic;
        pcs8gwrenabletx : out    vl_logic;
        pcsgen3txrst    : out    vl_logic;
        pcsgen3txrstn   : out    vl_logic;
        pld10gtxbitslip : in     vl_logic_vector(6 downto 0);
        pld10gtxbursten : in     vl_logic;
        pld10gtxburstenexe: out    vl_logic;
        pld10gtxclkout  : out    vl_logic;
        pld10gtxcontrol : in     vl_logic_vector(8 downto 0);
        pld10gtxdatavalid: in     vl_logic;
        pld10gtxdiagstatus: in     vl_logic_vector(1 downto 0);
        pld10gtxempty   : out    vl_logic;
        pld10gtxfifodel : out    vl_logic;
        pld10gtxfifoinsert: out    vl_logic;
        pld10gtxframe   : out    vl_logic;
        pld10gtxfull    : out    vl_logic;
        pld10gtxpempty  : out    vl_logic;
        pld10gtxpfull   : out    vl_logic;
        pld10gtxpldclk  : in     vl_logic;
        pld10gtxpldrstn : in     vl_logic;
        pld10gtxwordslip: in     vl_logic;
        pld10gtxwordslipexe: out    vl_logic;
        pld8gemptytx    : out    vl_logic;
        pld8gfulltx     : out    vl_logic;
        pld8gphfifoursttxn: in     vl_logic;
        pld8gpldtxclk   : in     vl_logic;
        pld8gpolinvtx   : in     vl_logic;
        pld8grddisabletx: in     vl_logic;
        pld8grevloopbk  : in     vl_logic;
        pld8gtxblkstart : in     vl_logic_vector(3 downto 0);
        pld8gtxboundarysel: in     vl_logic_vector(4 downto 0);
        pld8gtxclkout   : out    vl_logic;
        pld8gtxdatavalid: in     vl_logic_vector(3 downto 0);
        pld8gtxsynchdr  : in     vl_logic_vector(1 downto 0);
        pld8gtxurstpcsn : in     vl_logic;
        pld8gwrenabletx : in     vl_logic;
        pldclkdiv33lc   : out    vl_logic;
        pldgen3txrstn   : in     vl_logic;
        pldlccmurstbout : out    vl_logic;
        pldtxiqclkout   : out    vl_logic;
        pldtxpmasyncpfbkpout: out    vl_logic;
        pmaclkdiv33lc   : in     vl_logic;
        pmatxcmuplllock : in     vl_logic;
        pmatxlcplllock  : in     vl_logic;
        reset           : out    vl_logic;
        rstsel          : in     vl_logic;
        usrrstsel       : in     vl_logic
    );
end stratixv_hssi_tx_pld_pcs_interface_rbc;
