library verilog;
use verilog.vl_types.all;
entity sv_pma is
    generic(
        rx_enable       : integer := 1;
        tx_enable       : integer := 1;
        bonded_lanes    : integer := 1;
        bonding_master_ch: integer := 0;
        bonding_master_only: string  := "false";
        channel_number  : integer := 0;
        plls            : integer := 1;
        pll_sel         : integer := 0;
        pma_prot_mode   : string  := "basic";
        pma_mode        : integer := 8;
        pma_data_rate   : string  := "1250000000 bps";
        cdr_reference_clock_frequency: string  := "100 Mhz";
        auto_negotiation: string  := "<auto_single>";
        tx_clk_div      : integer := 1
    );
    port(
        calclk          : in     vl_logic_vector;
        seriallpbken    : in     vl_logic_vector;
        pciesw          : in     vl_logic_vector;
        txpmasyncp      : in     vl_logic_vector;
        rx_rstn         : in     vl_logic_vector;
        rx_crurstn      : in     vl_logic_vector;
        rx_datain       : in     vl_logic_vector;
        rx_bslip        : in     vl_logic_vector;
        rx_cdr_ref_clk  : in     vl_logic_vector;
        rx_ltr          : in     vl_logic_vector;
        rx_ltd          : in     vl_logic_vector;
        rx_freqlock     : in     vl_logic_vector;
        rx_earlyeios    : in     vl_logic_vector;
        rx_adaptcapture : in     vl_logic_vector;
        rx_adcestandby  : in     vl_logic_vector;
        rx_hardoccalen  : in     vl_logic_vector;
        rx_eyemonitor   : in     vl_logic_vector;
        rx_clkdivrx     : out    vl_logic_vector;
        rx_dataout      : out    vl_logic_vector;
        rx_sd           : out    vl_logic_vector;
        rx_clklow       : out    vl_logic_vector;
        rx_fref         : out    vl_logic_vector;
        rx_is_lockedtodata: out    vl_logic_vector;
        rx_is_lockedtoref: out    vl_logic_vector;
        rx_adaptdone    : out    vl_logic_vector;
        rx_hardoccaldone: out    vl_logic_vector;
        out_pcs_signal_ok: out    vl_logic_vector;
        out_pcs_rx_pll_phase_lock_out: out    vl_logic_vector;
        tx_datain       : in     vl_logic_vector;
        tx_txelecidl    : in     vl_logic_vector;
        tx_rxdetclk     : in     vl_logic;
        tx_txdetrx      : in     vl_logic_vector;
        tx_dataout      : out    vl_logic_vector;
        tx_rxdetectvalid: out    vl_logic_vector;
        tx_rxfound      : out    vl_logic_vector;
        tx_rstn         : in     vl_logic;
        tx_clkdivtx     : out    vl_logic_vector;
        tx_ser_clk      : in     vl_logic_vector;
        tx_pcieswdone   : out    vl_logic_vector;
        pma_avmmrstn    : in     vl_logic_vector;
        pma_avmmclk     : in     vl_logic_vector;
        pma_avmmwrite   : in     vl_logic_vector;
        pma_avmmread    : in     vl_logic_vector;
        pma_avmmbyteen  : in     vl_logic_vector;
        pma_avmmaddress : in     vl_logic_vector;
        pma_avmmwritedata: in     vl_logic_vector;
        pma_avmmreaddata_tx_cgb: out    vl_logic_vector;
        pma_avmmreaddata_tx_ser: out    vl_logic_vector;
        pma_avmmreaddata_tx_buf: out    vl_logic_vector;
        pma_avmmreaddata_rx_ser: out    vl_logic_vector;
        pma_avmmreaddata_rx_buf: out    vl_logic_vector;
        pma_avmmreaddata_rx_cdr: out    vl_logic_vector;
        pma_avmmreaddata_rx_mux: out    vl_logic_vector;
        pma_blockselect_tx_cgb: out    vl_logic_vector;
        pma_blockselect_tx_ser: out    vl_logic_vector;
        pma_blockselect_tx_buf: out    vl_logic_vector;
        pma_blockselect_rx_ser: out    vl_logic_vector;
        pma_blockselect_rx_buf: out    vl_logic_vector;
        pma_blockselect_rx_cdr: out    vl_logic_vector;
        pma_blockselect_rx_mux: out    vl_logic_vector
    );
end sv_pma;
