library verilog;
use verilog.vl_types.all;
entity sv_rx_pma is
    generic(
        bonded_lanes    : integer := 1;
        bonding_master_ch_num: integer := 0;
        bonding_master_only: string  := "false";
        mode            : integer := 8;
        serial_loopback : string  := "lpbkp_dis";
        sdclk_enable    : string  := "true";
        channel_number  : integer := 0;
        auto_negotiation: string  := "false";
        cdr_reference_clock_frequency: string  := "100 Mhz";
        cdr_output_clock_frequency: string  := "2500 Mhz";
        rxpll_pd_bw_ctrl: integer := 300
    );
    port(
        calclk          : in     vl_logic_vector;
        rstn            : in     vl_logic_vector;
        crurstn         : in     vl_logic_vector;
        datain          : in     vl_logic_vector;
        seriallpbkin    : in     vl_logic_vector;
        seriallpbken    : in     vl_logic_vector;
        bslip           : in     vl_logic_vector;
        adaptcapture    : in     vl_logic_vector;
        adcestandby     : in     vl_logic_vector;
        hardoccalen     : in     vl_logic_vector;
        eyemonitor      : in     vl_logic_vector;
        adaptdone       : out    vl_logic_vector;
        hardoccaldone   : out    vl_logic_vector;
        sd              : out    vl_logic_vector;
        cdr_ref_clk     : in     vl_logic_vector;
        pciesw          : in     vl_logic_vector;
        ltr             : in     vl_logic_vector;
        ltd             : in     vl_logic_vector;
        freqlock        : in     vl_logic_vector;
        earlyeios       : in     vl_logic_vector;
        clklow          : out    vl_logic_vector;
        fref            : out    vl_logic_vector;
        rx_is_lockedtodata: out    vl_logic_vector;
        rx_is_lockedtoref: out    vl_logic_vector;
        clkdivrx        : out    vl_logic_vector;
        dout            : out    vl_logic_vector;
        avmmrstn        : in     vl_logic_vector;
        avmmclk         : in     vl_logic_vector;
        avmmwrite       : in     vl_logic_vector;
        avmmread        : in     vl_logic_vector;
        avmmbyteen      : in     vl_logic_vector;
        avmmaddress     : in     vl_logic_vector;
        avmmwritedata   : in     vl_logic_vector;
        avmmreaddata_ser: out    vl_logic_vector;
        avmmreaddata_buf: out    vl_logic_vector;
        avmmreaddata_cdr: out    vl_logic_vector;
        avmmreaddata_mux: out    vl_logic_vector;
        blockselect_ser : out    vl_logic_vector;
        blockselect_buf : out    vl_logic_vector;
        blockselect_cdr : out    vl_logic_vector;
        blockselect_mux : out    vl_logic_vector;
        rdlpbkp         : out    vl_logic_vector;
        rdlpbkn         : out    vl_logic_vector
    );
end sv_rx_pma;
