library verilog;
use verilog.vl_types.all;
entity sv_tx_pma is
    generic(
        bonded_lanes    : integer := 1;
        bonding_master_ch_num: integer := 0;
        bonding_master_only: string  := "false";
        data_rate       : string  := "0 ps";
        mode            : integer := 8;
        channel_number  : integer := 0;
        ser_loopback    : string  := "false";
        auto_negotiation: string  := "false";
        plls            : integer := 1;
        pll_sel         : integer := 0;
        pclksel         : string  := "local_pclk";
        ht_delay_sel    : string  := "false";
        rx_det_pdb      : string  := "true";
        tx_clk_div      : integer := 1
    );
    port(
        calclk          : in     vl_logic_vector;
        datain          : in     vl_logic_vector;
        txelecidl       : in     vl_logic_vector;
        rxdetclk        : in     vl_logic;
        txdetrx         : in     vl_logic_vector;
        dataout         : out    vl_logic_vector;
        rxdetectvalid   : out    vl_logic_vector;
        rxfound         : out    vl_logic_vector;
        rstn            : in     vl_logic;
        seriallpbken    : in     vl_logic_vector;
        clkdivtx        : out    vl_logic_vector;
        seriallpbkout   : out    vl_logic_vector;
        clk             : in     vl_logic_vector;
        pciesw          : in     vl_logic_vector(1 downto 0);
        txpmasyncp      : in     vl_logic_vector;
        pcieswdone      : out    vl_logic_vector;
        avmmrstn        : in     vl_logic_vector;
        avmmclk         : in     vl_logic_vector;
        avmmwrite       : in     vl_logic_vector;
        avmmread        : in     vl_logic_vector;
        avmmbyteen      : in     vl_logic_vector;
        avmmaddress     : in     vl_logic_vector;
        avmmwritedata   : in     vl_logic_vector;
        avmmreaddata_cgb: out    vl_logic_vector;
        avmmreaddata_ser: out    vl_logic_vector;
        avmmreaddata_buf: out    vl_logic_vector;
        blockselect_cgb : out    vl_logic_vector;
        blockselect_ser : out    vl_logic_vector;
        blockselect_buf : out    vl_logic_vector;
        vrlpbkp         : in     vl_logic_vector;
        vrlpbkn         : in     vl_logic_vector
    );
end sv_tx_pma;
