library verilog;
use verilog.vl_types.all;
entity sv_tx_pma_ch is
    generic(
        mode            : integer := 8;
        channel_number  : integer := 0;
        auto_negotiation: string  := "false";
        plls            : integer := 1;
        pll_sel         : integer := 0;
        ser_loopback    : string  := "false";
        ht_delay_sel    : string  := "false";
        tx_pma_type     : string  := "SINGLE_CHANNEL";
        data_rate       : string  := "0 ps";
        rx_det_pdb      : string  := "true";
        tx_clk_div      : integer := 1
    );
    port(
        calclk          : in     vl_logic;
        datain          : in     vl_logic_vector(79 downto 0);
        txelecidl       : in     vl_logic;
        rxdetclk        : in     vl_logic;
        txdetrx         : in     vl_logic;
        dataout         : out    vl_logic;
        rxdetectvalid   : out    vl_logic;
        rxfound         : out    vl_logic;
        rstn            : in     vl_logic;
        seriallpbken    : in     vl_logic;
        clkdivtx        : out    vl_logic;
        seriallpbkout   : out    vl_logic;
        clk             : in     vl_logic_vector;
        pciesw          : in     vl_logic_vector(1 downto 0);
        txpmasyncp      : in     vl_logic;
        cpulsein        : in     vl_logic;
        hfclkpin        : in     vl_logic;
        lfclkpin        : in     vl_logic;
        pclkin          : in     vl_logic_vector(2 downto 0);
        pcieswdone      : out    vl_logic_vector(1 downto 0);
        hfclkpout       : out    vl_logic;
        lfclkpout       : out    vl_logic;
        cpulseout       : out    vl_logic;
        pclkout         : out    vl_logic_vector(2 downto 0);
        avmmrstn        : in     vl_logic;
        avmmclk         : in     vl_logic;
        avmmwrite       : in     vl_logic;
        avmmread        : in     vl_logic;
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata_cgb: out    vl_logic_vector(15 downto 0);
        avmmreaddata_ser: out    vl_logic_vector(15 downto 0);
        avmmreaddata_buf: out    vl_logic_vector(15 downto 0);
        blockselect_cgb : out    vl_logic;
        blockselect_ser : out    vl_logic;
        blockselect_buf : out    vl_logic;
        vrlpbkp         : in     vl_logic;
        vrlpbkn         : in     vl_logic
    );
end sv_tx_pma_ch;
