library verilog;
use verilog.vl_types.all;
entity sv_xcvr_avmm is
    generic(
        bonded_lanes    : integer := 1;
        bonding_master_ch: integer := 0;
        bonding_master_only: string  := "false";
        enable_avmm     : integer := 1
    );
    port(
        reconfig_to_xcvr: in     vl_logic_vector;
        reconfig_from_xcvr: out    vl_logic_vector;
        calclk          : out    vl_logic_vector;
        pma_adaptdone   : in     vl_logic_vector;
        pma_hardoccaldone: in     vl_logic_vector;
        pma_eyemonitor  : out    vl_logic_vector;
        pma_hardoccalen : out    vl_logic_vector;
        pma_adcecapture : out    vl_logic_vector;
        pma_adcestandby : out    vl_logic_vector;
        chnl_avmm_clk   : out    vl_logic_vector;
        chnl_avmm_rstn  : out    vl_logic_vector;
        chnl_avmm_writedata: out    vl_logic_vector;
        chnl_avmm_address: out    vl_logic_vector;
        chnl_avmm_write : out    vl_logic_vector;
        chnl_avmm_read  : out    vl_logic_vector;
        chnl_avmm_byteen: out    vl_logic_vector;
        pma_avmmreaddata_tx_cgb: in     vl_logic_vector;
        pma_avmmreaddata_tx_ser: in     vl_logic_vector;
        pma_avmmreaddata_tx_buf: in     vl_logic_vector;
        pma_avmmreaddata_rx_ser: in     vl_logic_vector;
        pma_avmmreaddata_rx_buf: in     vl_logic_vector;
        pma_avmmreaddata_rx_cdr: in     vl_logic_vector;
        pma_avmmreaddata_rx_mux: in     vl_logic_vector;
        pma_blockselect_tx_cgb: in     vl_logic_vector;
        pma_blockselect_tx_ser: in     vl_logic_vector;
        pma_blockselect_tx_buf: in     vl_logic_vector;
        pma_blockselect_rx_ser: in     vl_logic_vector;
        pma_blockselect_rx_buf: in     vl_logic_vector;
        pma_blockselect_rx_cdr: in     vl_logic_vector;
        pma_blockselect_rx_mux: in     vl_logic_vector;
        avmmreaddata_com_pcs_pma_if: in     vl_logic_vector;
        avmmreaddata_com_pld_pcs_if: in     vl_logic_vector;
        avmmreaddata_pcs10g_rx: in     vl_logic_vector;
        avmmreaddata_pcs10g_tx: in     vl_logic_vector;
        avmmreaddata_pcs8g_rx: in     vl_logic_vector;
        avmmreaddata_pcs8g_tx: in     vl_logic_vector;
        avmmreaddata_pcs_g3_rx: in     vl_logic_vector;
        avmmreaddata_pcs_g3_tx: in     vl_logic_vector;
        avmmreaddata_pipe12: in     vl_logic_vector;
        avmmreaddata_pipe3: in     vl_logic_vector;
        avmmreaddata_rx_pcs_pma_if: in     vl_logic_vector;
        avmmreaddata_rx_pld_pcs_if: in     vl_logic_vector;
        avmmreaddata_tx_pcs_pma_if: in     vl_logic_vector;
        avmmreaddata_tx_pld_pcs_if: in     vl_logic_vector;
        blockselect_com_pcs_pma_if: in     vl_logic_vector;
        blockselect_com_pld_pcs_if: in     vl_logic_vector;
        blockselect_pcs10g_rx: in     vl_logic_vector;
        blockselect_pcs10g_tx: in     vl_logic_vector;
        blockselect_pcs8g_rx: in     vl_logic_vector;
        blockselect_pcs8g_tx: in     vl_logic_vector;
        blockselect_pcs_g3_rx: in     vl_logic_vector;
        blockselect_pcs_g3_tx: in     vl_logic_vector;
        blockselect_pipe12: in     vl_logic_vector;
        blockselect_pipe3: in     vl_logic_vector;
        blockselect_rx_pcs_pma_if: in     vl_logic_vector;
        blockselect_rx_pld_pcs_if: in     vl_logic_vector;
        blockselect_tx_pcs_pma_if: in     vl_logic_vector;
        blockselect_tx_pld_pcs_if: in     vl_logic_vector
    );
end sv_xcvr_avmm;
