library verilog;
use verilog.vl_types.all;
entity sv_xcvr_custom_native is
    generic(
        protocol_hint   : string  := "basic";
        operation_mode  : string  := "Duplex";
        lanes           : integer := 1;
        bonded_group_size: integer := 1;
        ser_base_factor : integer := 8;
        ser_words       : integer := 1;
        data_rate       : string  := "1250 Mbps";
        base_data_rate  : string  := "0 Mbps";
        tx_bitslip_enable: string  := "false";
        tx_use_coreclk  : string  := "false";
        rx_use_coreclk  : string  := "false";
        use_8b10b       : string  := "false";
        use_8b10b_manual_control: string  := "false";
        word_aligner_mode: string  := "bitslip";
        word_aligner_state_machine_datacnt: integer := 0;
        word_aligner_state_machine_errcnt: integer := 0;
        word_aligner_state_machine_patterncnt: integer := 0;
        word_aligner_pattern_length: integer := 7;
        word_align_pattern: string  := "0000000000";
        run_length_violation_checking: integer := 0;
        use_rate_match_fifo: integer := 0;
        rate_match_pattern1: string  := "00000000000000000000";
        rate_match_pattern2: string  := "00000000000000000000";
        byte_order_mode : string  := "None";
        byte_order_pattern: string  := "0";
        byte_order_pad_pattern: string  := "0";
        use_double_data_mode: string  := "auto";
        coreclk_0ppm_enable: string  := "false";
        pll_refclk_cnt  : integer := 1;
        pll_refclk_freq : string  := "125 MHz";
        plls            : integer := 1;
        starting_channel_number: integer := 0;
        low_latency_mode: string  := "false"
    );
    port(
        tx_analogreset  : in     vl_logic;
        pll_powerdown   : in     vl_logic_vector;
        tx_digitalreset : in     vl_logic_vector;
        rx_analogreset  : in     vl_logic_vector;
        rx_digitalreset : in     vl_logic_vector;
        pll_ref_clk     : in     vl_logic_vector;
        tx_coreclkin    : in     vl_logic_vector;
        rx_coreclkin    : in     vl_logic_vector;
        tx_parallel_data: in     vl_logic_vector;
        rx_parallel_data: out    vl_logic_vector;
        tx_datak        : in     vl_logic_vector;
        rx_datak        : out    vl_logic_vector;
        tx_forcedisp    : in     vl_logic_vector;
        tx_dispval      : in     vl_logic_vector;
        rx_enabyteord   : in     vl_logic_vector;
        rx_serial_data  : in     vl_logic_vector;
        tx_serial_data  : out    vl_logic_vector;
        tx_clkout       : out    vl_logic_vector;
        rx_clkout       : out    vl_logic_vector;
        rx_recovered_clk: out    vl_logic_vector;
        tx_forceelecidle: in     vl_logic_vector;
        tx_invpolarity  : in     vl_logic_vector;
        tx_bitslipboundaryselect: in     vl_logic_vector;
        rx_invpolarity  : in     vl_logic_vector;
        rx_seriallpbken : in     vl_logic_vector;
        rx_set_locktodata: in     vl_logic_vector;
        rx_set_locktoref: in     vl_logic_vector;
        rx_enapatternalign: in     vl_logic_vector;
        rx_bitslip      : in     vl_logic_vector;
        rx_bitreversalenable: in     vl_logic_vector;
        rx_bytereversalenable: in     vl_logic_vector;
        rx_a1a2size     : in     vl_logic_vector;
        rx_rlv          : out    vl_logic_vector;
        rx_patterndetect: out    vl_logic_vector;
        rx_syncstatus   : out    vl_logic_vector;
        rx_bitslipboundaryselectout: out    vl_logic_vector;
        rx_errdetect    : out    vl_logic_vector;
        rx_disperr      : out    vl_logic_vector;
        rx_runningdisp  : out    vl_logic_vector;
        rx_rmfifofull   : out    vl_logic_vector;
        rx_rmfifoempty  : out    vl_logic_vector;
        rx_rmfifodatainserted: out    vl_logic_vector;
        rx_rmfifodatadeleted: out    vl_logic_vector;
        rx_a1a2sizeout  : out    vl_logic_vector;
        rx_is_lockedtoref: out    vl_logic_vector;
        rx_signaldetect : out    vl_logic_vector;
        rx_is_lockedtodata: out    vl_logic_vector;
        pll_locked      : out    vl_logic_vector;
        rx_phase_comp_fifo_error: out    vl_logic_vector;
        tx_phase_comp_fifo_error: out    vl_logic_vector;
        rx_byteordflag  : out    vl_logic_vector;
        reconfig_to_xcvr: in     vl_logic_vector;
        reconfig_from_xcvr: out    vl_logic_vector
    );
end sv_xcvr_custom_native;
