library verilog;
use verilog.vl_types.all;
entity sv_xrbasic_lif_csr is
    generic(
        logical_interface: integer := 0;
        native_ifs      : integer := 1;
        w_lch           : integer := 5;
        w_pif           : integer := 5;
        w_pch           : integer := 3;
        w_paddr         : integer := 11;
        physical_channel_mapping: string  := ""
    );
    port(
        reconfig_clk    : in     vl_logic;
        reset           : in     vl_logic;
        lif_is_active   : in     vl_logic;
        basic_reconfig_write: in     vl_logic;
        basic_reconfig_read: in     vl_logic;
        basic_reconfig_writedata: in     vl_logic_vector(31 downto 0);
        basic_reconfig_address: in     vl_logic_vector(2 downto 0);
        basic_reconfig_readdata: out    vl_logic_vector(31 downto 0);
        basic_reconfig_waitrequest: out    vl_logic;
        pif_number      : out    vl_logic_vector;
        pch_number      : out    vl_logic_vector;
        reg_rwdata      : out    vl_logic_vector(15 downto 0);
        plock_get       : out    vl_logic;
        plock_granted   : in     vl_logic;
        testbus_sel     : out    vl_logic_vector(3 downto 0);
        testbus_adce_capture: out    vl_logic;
        testbus_adce_standby: out    vl_logic;
        testbus_hardoc_cal_en: out    vl_logic;
        reco_read       : out    vl_logic;
        reco_write      : out    vl_logic;
        reco_addr       : out    vl_logic_vector;
        reco_rdata      : in     vl_logic_vector(15 downto 0)
    );
end sv_xrbasic_lif_csr;
