
set QUARTUS_ROOTDIR $env(QUARTUS_ROOTDIR)
set simulator_lib mentor

vlib work
vlib sv_generic

###########################################
# Stratix V library files 
###########################################
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/altera_lnsim.sv
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/stratixv_atoms.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/stratixv_hssi_atoms.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/mentor/stratixv_atoms_ncrypt.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/mentor/stratixv_hssi_atoms_ncrypt.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/220model.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/altera_primitives.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/sgate.v
vlog -work sv_generic $QUARTUS_ROOTDIR/eda/sim_lib/altera_mf.v

###########################################
# PHY Instance top_custom
###########################################
vlib msim_top_custom
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_common_h.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_pcs8g_h.sv
vlog -work msim_top_custom -sv top_custom/altera_xcvr_functions.sv
vlog -work msim_top_custom top_custom_sim/altera_xcvr_custom_phy/altera_wait_generate.v
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/altera_xcvr_custom.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/altera_xcvr_functions.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_reset_ctrl_lego.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_reset_ctrl_tgx_cdrauto.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_arbiter.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_common.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_common_h.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_pcs8g.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_pcs8g_h.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_csr_selector.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_m2s.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_mgmt2dec.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/alt_xcvr_resync.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_10g_rx_pcs_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_10g_tx_pcs_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_8g_rx_pcs_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_8g_tx_pcs_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_common_pcs_pma_interface_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_common_pld_pcs_interface_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_pipe_gen1_2_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_pipe_gen3_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_rx_pcs_pma_interface_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_rx_pld_pcs_interface_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_tx_pcs_pma_interface_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/stratixv_hssi_tx_pld_pcs_interface_rbc.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_pcs.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_pcs_ch.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_pma.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_reconfig_bundle_merger.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_reconfig_bundle_to_ip.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_reconfig_bundle_to_xcvr.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_rx_pma.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_tx_pma.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_tx_pma_ch.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_xcvr_avmm.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_xcvr_custom_native.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_xcvr_custom_nr.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_xcvr_data_adapter.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_xcvr_native.sv
vlog -work msim_top_custom -sv top_custom_sim/altera_xcvr_custom_phy/sv_xcvr_plls.sv
vlog -work msim_top_custom ../source/top_custom.v

###########################################
# Reconfig Instance
###########################################

vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_h.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xcvr_h.sv
vlog -work msim_top_custom ../source/top_reconfig_sim/alt_xcvr_reconfig/altera_wait_generate.v
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/altera_xcvr_functions.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_arbiter_acq.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_arbiter.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_csr_selector.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_m2s.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_analog.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_analog_sv.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_basic.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_direct.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_h.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_offset_cancellation.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_offset_cancellation_sv.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xcvr_reconfig_sv.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xreconf_analog_ctrlsm.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xreconf_analog_datactrl.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xreconf_analog_rmw.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xreconf_basic_acq.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xreconf_cif.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/alt_xreconf_uif.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_reconfig_bundle_to_basic.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xcvr_h.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xcvr_reconfig_basic.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xrbasic_l2p_addr.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xrbasic_l2p_ch.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xrbasic_lif.sv
vlog -work msim_top_custom -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/sv_xrbasic_lif_csr.sv
vlog ../source/top_reconfig.v

###########################################
## Add User Design Files
###########################################
vlog -sv alt_xcvr_reconfig_h.sv
vlog ../source/mgmt_master1/mgmt_commands_h1.sv
vlog ../source/mgmt_master1/mgmt_functions_h1.sv
vlog ../source/mgmt_master1/mgmt_cpu1.sv

vlog ../source/mgmt_master1/mgmt_memory_map1.sv
vlog ../source/mgmt_master1/mgmt_program1.sv
vlog ../source/mgmt_master1/mgmt_master1.sv

vlog ../source/mgmt_master2/mgmt_commands_h2.sv
vlog ../source/mgmt_master2/mgmt_functions_h2.sv
vlog ../source/mgmt_master2/mgmt_cpu2.sv

vlog ../source/mgmt_master2/mgmt_memory_map2.sv
vlog ../source/mgmt_master2/mgmt_program2.sv
vlog ../source/mgmt_master2/mgmt_master2.sv

vlog ../source/mgmt_master3/mgmt_commands_h3.sv
vlog ../source/mgmt_master3/mgmt_functions_h3.sv
vlog ../source/mgmt_master3/mgmt_cpu3.sv

vlog ../source/mgmt_master3/mgmt_memory_map3.sv
vlog ../source/mgmt_master3/mgmt_program3.sv
vlog ../source/mgmt_master3/mgmt_master3.sv

vlog datagen_controller.v
vlog gxb_state_mc.v
vlog prbs_checker.v
vlog prbs_checker_x4.v
vlog prbs_generator.v
vlog prbs_poly.v
vlog syncgen_16bit_1lane.v
vlog syncgen_16bit_4lanes.v
vlog top.sv
vlog -sv ../source/top_reconfig_sim/alt_xcvr_reconfig/altera_xcvr_functions.sv
###########################################
## Top-level testbench 
###########################################
vlog ../source/top_tb.sv

###########################################
# Invoke simulator 
###########################################
 # vsim -c -novopt -t 1ps $tb_name 
#vsim -c -t 1ps top_tb
vsim  -c -novopt -t 1ps top_tb -L sv_generic -L msim_top_custom

do wave.do
run 75 us