library verilog;
use verilog.vl_types.all;
entity stratixv_atx_pll is
    generic(
        avmm_group_channel_index: integer := 0;
        output_clock_frequency: string  := "";
        reference_clock_frequency: string  := "";
        use_default_base_address: string  := "true";
        user_base_address0: integer := 0;
        user_base_address1: integer := 0;
        user_base_address2: integer := 0;
        cp_current_ctrl : integer := 300;
        cp_current_test : string  := "enable_ch_pump_normal";
        cp_hs_levshift_power_supply_setting: integer := 1;
        cp_replica_bias_ctrl: string  := "disable_replica_bias_ctrl";
        cp_rgla_bypass  : string  := "false";
        cp_rgla_volt_inc: string  := "boost_30pct";
        l_counter       : integer := 1;
        lcpll_atb_select: string  := "atb_disable";
        lcpll_d2a_sel   : string  := "volt_1p02v";
        lcpll_hclk_driver_enable: string  := "driver_off";
        lcvco_gear_sel  : string  := "high_gear";
        lcvco_sel       : string  := "high_freq_14g";
        lpf_ripple_cap_ctrl: string  := "none";
        lpf_rxpll_pfd_bw_ctrl: integer := 2400;
        m_counter       : integer := 4;
        ref_clk_div     : integer := 1;
        refclk_sel      : string  := "refclk";
        vreg1_lcvco_volt_inc: string  := "volt_1p1v";
        vreg1_vccehlow  : string  := "normal_operation";
        vreg2_lcpll_volt_sel: string  := "vreg2_volt_1p0v";
        vreg3_lcpll_volt_sel: string  := "vreg3_volt_1p0v"
    );
    port(
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmclk         : in     vl_logic_vector(0 downto 0);
        avmmread        : in     vl_logic_vector(0 downto 0);
        avmmrstn        : in     vl_logic_vector(0 downto 0);
        avmmwrite       : in     vl_logic_vector(0 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic_vector(0 downto 0);
        ch0rcsrlc       : in     vl_logic_vector(31 downto 0);
        ch1rcsrlc       : in     vl_logic_vector(31 downto 0);
        ch2rcsrlc       : in     vl_logic_vector(31 downto 0);
        cmurstn         : in     vl_logic_vector(0 downto 0);
        cmurstnlpf      : in     vl_logic_vector(0 downto 0);
        extfbclk        : in     vl_logic_vector(0 downto 0);
        iqclklc         : in     vl_logic_vector(0 downto 0);
        pldclklc        : in     vl_logic_vector(0 downto 0);
        pllfbswblc      : in     vl_logic_vector(0 downto 0);
        pllfbswtlc      : in     vl_logic_vector(0 downto 0);
        refclklc        : in     vl_logic_vector(0 downto 0);
        clk010g         : out    vl_logic_vector(0 downto 0);
        clk025g         : out    vl_logic_vector(0 downto 0);
        clk18010g       : out    vl_logic_vector(0 downto 0);
        clk18025g       : out    vl_logic_vector(0 downto 0);
        clk33cmu        : out    vl_logic_vector(0 downto 0);
        clklowcmu       : out    vl_logic_vector(0 downto 0);
        frefcmu         : out    vl_logic_vector(0 downto 0);
        iqclkatt        : out    vl_logic_vector(0 downto 0);
        pfdmodelockcmu  : out    vl_logic_vector(0 downto 0);
        pldclkatt       : out    vl_logic_vector(0 downto 0);
        refclkatt       : out    vl_logic_vector(0 downto 0);
        txpllhclk       : out    vl_logic_vector(0 downto 0)
    );
end stratixv_atx_pll;
