library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_pipe_gen3 is
    generic(
        enable_debug_info: string  := "false";
        mode            : string  := "pipe_g1";
        ctrl_plane_bonding: string  := "individual";
        pipe_clk_sel    : string  := "func_clk";
        rate_match_pad_insertion: string  := "dis_rm_fifo_pad_ins";
        ind_error_reporting: string  := "dis_ind_error_reporting";
        phystatus_rst_toggle_g3: string  := "dis_phystatus_rst_toggle_g3";
        phystatus_rst_toggle_g12: string  := "dis_phystatus_rst_toggle";
        cdr_control     : string  := "en_cdr_ctrl";
        cid_enable      : string  := "en_cid_mode";
        parity_chk_ts1  : string  := "en_ts1_parity_chk";
        rxvalid_mask    : string  := "rxvalid_mask_en";
        ph_fifo_reg_mode: string  := "phfifo_reg_mode_dis";
        test_mode_timers: string  := "dis_test_mode_timers";
        inf_ei_enable   : string  := "dis_inf_ei";
        spd_chnge_g2_sel: string  := "false";
        cp_up_mstr      : string  := "false";
        cp_dwn_mstr     : string  := "false";
        cp_cons_sel     : string  := "cp_cons_default";
        elecidle_delay_g3_data: integer := 0;
        elecidle_delay_g3: string  := "elecidle_delay_g3";
        phy_status_delay_g12_data: integer := 0;
        phy_status_delay_g12: string  := "phy_status_delay_g12";
        phy_status_delay_g3_data: integer := 0;
        phy_status_delay_g3: string  := "phy_status_delay_g3";
        sigdet_wait_counter_data: integer := 0;
        sigdet_wait_counter: string  := "sigdet_wait_counter";
        data_mask_count_val: integer := 0;
        data_mask_count : string  := "data_mask_count";
        pma_done_counter_data: integer := 0;
        pma_done_counter: string  := "pma_done_count";
        pc_en_counter_data: integer := 0;
        pc_en_counter   : string  := "pc_en_count";
        pc_rst_counter_data: integer := 0;
        pc_rst_counter  : string  := "pc_rst_count";
        phfifo_flush_wait_data: integer := 0;
        phfifo_flush_wait: string  := "phfifo_flush_wait";
        asn_clk_enable  : string  := "false";
        free_run_clk_enable: string  := "true";
        asn_enable      : string  := "dis_asn";
        bypass_send_syncp_fbkp: string  := "false";
        wait_send_syncp_fbkp_data: integer := 250;
        wait_clk_on_off_timer_data: integer := 4;
        wait_clk_on_off_timer: string  := "wait_clk_on_off_timer";
        wait_send_syncp_fbkp: string  := "wait_send_syncp_fbkp";
        wait_pipe_synchronizing: string  := "wait_pipe_sync";
        bypass_pma_sw_done: string  := "false";
        test_out_sel    : string  := "disable";
        wait_pipe_synchronizing_data: integer := 23;
        sup_mode        : string  := "user_mode";
        avmm_group_channel_index: integer := 0;
        use_default_base_address: string  := "true";
        user_base_address: integer := 0
    );
    port(
        rxtestout       : in     vl_logic_vector(19 downto 0);
        txpmasyncp      : out    vl_logic_vector(0 downto 0);
        ppmcntrst8gpcsout: out    vl_logic_vector(0 downto 0);
        txpmasyncphip   : in     vl_logic_vector(0 downto 0);
        hardresetn      : in     vl_logic_vector(0 downto 0);
        bundlingindown  : in     vl_logic_vector(10 downto 0);
        bundlingoutdown : out    vl_logic_vector(10 downto 0);
        bundlingoutup   : out    vl_logic_vector(10 downto 0);
        bundlinginup    : in     vl_logic_vector(10 downto 0);
        rcvdclk         : in     vl_logic_vector(0 downto 0);
        txpmaclk        : in     vl_logic_vector(0 downto 0);
        pllfixedclk     : in     vl_logic_vector(0 downto 0);
        rtxgen3capen    : in     vl_logic_vector(0 downto 0);
        rrxgen3capen    : in     vl_logic_vector(0 downto 0);
        rtxdigclksel    : in     vl_logic_vector(0 downto 0);
        rrxdigclksel    : in     vl_logic_vector(0 downto 0);
        rxrstn          : in     vl_logic_vector(0 downto 0);
        txrstn          : in     vl_logic_vector(0 downto 0);
        scanmoden       : in     vl_logic_vector(0 downto 0);
        testout         : out    vl_logic_vector(19 downto 0);
        gen3datasel     : out    vl_logic_vector(0 downto 0);
        gen3clksel      : out    vl_logic_vector(0 downto 0);
        pcsrst          : out    vl_logic_vector(0 downto 0);
        dispcbyte       : out    vl_logic_vector(0 downto 0);
        resetpcprts     : out    vl_logic_vector(0 downto 0);
        shutdownclk     : out    vl_logic_vector(0 downto 0);
        txdata          : in     vl_logic_vector(31 downto 0);
        txdatak         : in     vl_logic_vector(3 downto 0);
        txdataskip      : in     vl_logic_vector(0 downto 0);
        txsynchdr       : in     vl_logic_vector(1 downto 0);
        txblkstart      : in     vl_logic_vector(0 downto 0);
        txelecidle      : in     vl_logic_vector(0 downto 0);
        txdetectrxloopback: in     vl_logic_vector(0 downto 0);
        txcompliance    : in     vl_logic_vector(0 downto 0);
        rxpolarity      : in     vl_logic_vector(0 downto 0);
        powerdown       : in     vl_logic_vector(1 downto 0);
        rate            : in     vl_logic_vector(1 downto 0);
        txmargin        : in     vl_logic_vector(2 downto 0);
        txdeemph        : in     vl_logic_vector(0 downto 0);
        txswing         : in     vl_logic_vector(0 downto 0);
        eidleinfersel   : in     vl_logic_vector(2 downto 0);
        currentcoeff    : in     vl_logic_vector(17 downto 0);
        currentrxpreset : in     vl_logic_vector(2 downto 0);
        rxupdatefc      : in     vl_logic_vector(0 downto 0);
        rxdataskip      : out    vl_logic_vector(3 downto 0);
        rxsynchdr       : out    vl_logic_vector(1 downto 0);
        rxblkstart      : out    vl_logic_vector(3 downto 0);
        rxvalid         : out    vl_logic_vector(0 downto 0);
        phystatus       : out    vl_logic_vector(0 downto 0);
        rxelecidle      : out    vl_logic_vector(0 downto 0);
        rxstatus        : out    vl_logic_vector(2 downto 0);
        rxdataint       : in     vl_logic_vector(31 downto 0);
        rxdatakint      : in     vl_logic_vector(3 downto 0);
        rxdataskipint   : in     vl_logic_vector(0 downto 0);
        rxsynchdrint    : in     vl_logic_vector(1 downto 0);
        rxblkstartint   : in     vl_logic_vector(0 downto 0);
        txdataint       : out    vl_logic_vector(31 downto 0);
        txdatakint      : out    vl_logic_vector(3 downto 0);
        txdataskipint   : out    vl_logic_vector(0 downto 0);
        txsynchdrint    : out    vl_logic_vector(1 downto 0);
        txblkstartint   : out    vl_logic_vector(0 downto 0);
        testinfei       : out    vl_logic_vector(18 downto 0);
        eidetint        : in     vl_logic_vector(0 downto 0);
        eipartialdetint : in     vl_logic_vector(0 downto 0);
        idetint         : in     vl_logic_vector(0 downto 0);
        blkalgndint     : in     vl_logic_vector(0 downto 0);
        clkcompinsertint: in     vl_logic_vector(0 downto 0);
        clkcompdeleteint: in     vl_logic_vector(0 downto 0);
        clkcompoverflint: in     vl_logic_vector(0 downto 0);
        clkcompundflint : in     vl_logic_vector(0 downto 0);
        errdecodeint    : in     vl_logic_vector(0 downto 0);
        rcvlfsrchkint   : in     vl_logic_vector(0 downto 0);
        errencodeint    : in     vl_logic_vector(0 downto 0);
        rxpolarityint   : out    vl_logic_vector(0 downto 0);
        revlpbkint      : out    vl_logic_vector(0 downto 0);
        inferredrxvalidint: out    vl_logic_vector(0 downto 0);
        rxd8gpcsin      : in     vl_logic_vector(63 downto 0);
        rxelecidle8gpcsin: in     vl_logic_vector(0 downto 0);
        pldltr          : in     vl_logic_vector(0 downto 0);
        rxd8gpcsout     : out    vl_logic_vector(63 downto 0);
        revlpbk8gpcsout : out    vl_logic_vector(0 downto 0);
        pmarxdetectvalid: in     vl_logic_vector(0 downto 0);
        pmarxfound      : in     vl_logic_vector(0 downto 0);
        pmasignaldet    : in     vl_logic_vector(0 downto 0);
        pmapcieswdone   : in     vl_logic_vector(1 downto 0);
        pmapcieswitch   : out    vl_logic_vector(1 downto 0);
        pmatxmargin     : out    vl_logic_vector(2 downto 0);
        pmatxdeemph     : out    vl_logic_vector(0 downto 0);
        pmatxswing      : out    vl_logic_vector(0 downto 0);
        pmacurrentcoeff : out    vl_logic_vector(17 downto 0);
        pmacurrentrxpreset: out    vl_logic_vector(2 downto 0);
        pmatxelecidle   : out    vl_logic_vector(0 downto 0);
        pmatxdetectrx   : out    vl_logic_vector(0 downto 0);
        ppmeidleexit    : out    vl_logic_vector(0 downto 0);
        pmaltr          : out    vl_logic_vector(0 downto 0);
        pmaearlyeios    : out    vl_logic_vector(0 downto 0);
        pmarxdetpd      : out    vl_logic_vector(0 downto 0);
        rxpolarity8gpcsout: out    vl_logic_vector(0 downto 0);
        speedchangeg2   : in     vl_logic_vector(0 downto 0);
        masktxpll       : out    vl_logic_vector(0 downto 0);
        avmmrstn        : in     vl_logic_vector(0 downto 0);
        avmmclk         : in     vl_logic_vector(0 downto 0);
        avmmwrite       : in     vl_logic_vector(0 downto 0);
        avmmread        : in     vl_logic_vector(0 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic_vector(0 downto 0)
    );
end stratixv_hssi_pipe_gen3;
