library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_pma_int is
    generic(
        enable_debug_info: string  := "false";
        early_eios_sel  : string  := "pcs_early_eios";
        ltr_sel         : string  := "pcs_ltr";
        pcie_switch_sel : string  := "pcs_pcie_switch_sw";
        ppm_lock_sel    : string  := "pcs_ppm_lock";
        lc_in_sel       : string  := "pcs_lc_in";
        txdetectrx_sel  : string  := "pcs_txdetectrx";
        tx_elec_idle_sel: string  := "pcs_tx_elec_idle";
        pclk_0_clk_sel  : string  := "pclk_0_power_down";
        pclk_1_clk_sel  : string  := "pclk_1_power_down";
        iqtxrxclk_a_sel : string  := "tristage_outa";
        iqtxrxclk_b_sel : string  := "tristage_outb";
        rx_data_out_sel : string  := "teng_mode";
        rx_bbpd_cal_en  : string  := "pcs_cal_en";
        dft_switch      : string  := "dft_switch_off";
        cvp_mode        : string  := "cvp_mode_off";
        channel_number  : integer := 0;
        ffclk_enable    : string  := "ffclk_off"
    );
    port(
        fref            : out    vl_logic_vector(0 downto 0);
        frefatti        : in     vl_logic_vector(0 downto 0);
        frefi           : in     vl_logic_vector(0 downto 0);
        hclkpcs         : out    vl_logic_vector(0 downto 0);
        hclkpcsi        : in     vl_logic_vector(0 downto 0);
        icoeff          : in     vl_logic_vector(17 downto 0);
        icoeffo         : out    vl_logic_vector(17 downto 0);
        irxpreset       : in     vl_logic_vector(2 downto 0);
        irxpreseto      : out    vl_logic_vector(2 downto 0);
        iqtxrxclka      : out    vl_logic_vector(0 downto 0);
        iqtxrxclkb      : out    vl_logic_vector(0 downto 0);
        lcin            : in     vl_logic_vector(0 downto 0);
        lcino           : out    vl_logic_vector(0 downto 0);
        lcout           : out    vl_logic_vector(1 downto 0);
        lcouti          : in     vl_logic_vector(1 downto 0);
        ltdo            : out    vl_logic_vector(0 downto 0);
        ltr             : in     vl_logic_vector(0 downto 0);
        ltro            : out    vl_logic_vector(0 downto 0);
        occaldone       : out    vl_logic_vector(0 downto 0);
        occaldoneatti   : in     vl_logic_vector(0 downto 0);
        occaldonei      : in     vl_logic_vector(0 downto 0);
        occalen         : in     vl_logic_vector(0 downto 0);
        occaleno        : out    vl_logic_vector(0 downto 0);
        pciefbclk       : in     vl_logic_vector(0 downto 0);
        pcieswdone      : out    vl_logic_vector(1 downto 0);
        pcieswdonei     : in     vl_logic_vector(1 downto 0);
        pcieswitch      : in     vl_logic_vector(1 downto 0);
        pcieswitcho     : out    vl_logic_vector(1 downto 0);
        pcsrxclkout     : in     vl_logic_vector(0 downto 0);
        pcstxclkout     : in     vl_logic_vector(0 downto 0);
        pfdmodelock     : out    vl_logic_vector(0 downto 0);
        pfdmodelockatti : in     vl_logic_vector(0 downto 0);
        pfdmodelocki    : in     vl_logic_vector(0 downto 0);
        adaptdone       : out    vl_logic_vector(0 downto 0);
        adaptdonei      : in     vl_logic_vector(0 downto 0);
        adcecapture     : in     vl_logic_vector(0 downto 0);
        adcecaptureo    : out    vl_logic_vector(0 downto 0);
        adcestandby     : in     vl_logic_vector(0 downto 0);
        adcestandbyo    : out    vl_logic_vector(0 downto 0);
        bslip           : in     vl_logic_vector(0 downto 0);
        bslipo          : out    vl_logic_vector(0 downto 0);
        byteen          : in     vl_logic_vector(1 downto 0);
        byteeno         : out    vl_logic_vector(1 downto 0);
        ccrurstb        : in     vl_logic_vector(0 downto 0);
        cearlyeios      : in     vl_logic_vector(0 downto 0);
        clcin           : in     vl_logic_vector(0 downto 0);
        clcout          : out    vl_logic_vector(1 downto 0);
        cltd            : in     vl_logic_vector(0 downto 0);
        cltr            : in     vl_logic_vector(0 downto 0);
        coccaldone      : out    vl_logic_vector(0 downto 0);
        coccalen        : in     vl_logic_vector(0 downto 0);
        cpcieswdone     : out    vl_logic_vector(1 downto 0);
        cpcieswitch     : in     vl_logic_vector(1 downto 0);
        cpclk           : out    vl_logic_vector(1 downto 0);
        cpfdmodelock    : out    vl_logic_vector(0 downto 0);
        cppmlock        : in     vl_logic_vector(0 downto 0);
        crslpbk         : in     vl_logic_vector(0 downto 0);
        crxdetectvalid  : out    vl_logic_vector(0 downto 0);
        crxfound        : out    vl_logic_vector(0 downto 0);
        crxplllock      : out    vl_logic_vector(0 downto 0);
        csd             : out    vl_logic_vector(0 downto 0);
        ctxelecidle     : in     vl_logic_vector(0 downto 0);
        ctxdetectrx     : in     vl_logic_vector(0 downto 0);
        ctxpmarstb      : in     vl_logic_vector(0 downto 0);
        clk33pcs        : out    vl_logic_vector(0 downto 0);
        clk33pcsi       : in     vl_logic_vector(0 downto 0);
        clkdivatti      : in     vl_logic_vector(0 downto 0);
        clkdivrx        : out    vl_logic_vector(0 downto 0);
        clkdivrxatti    : in     vl_logic_vector(0 downto 0);
        clkdivrxi       : in     vl_logic_vector(0 downto 0);
        clkdivtx        : out    vl_logic_vector(0 downto 0);
        clkdivtxatti    : in     vl_logic_vector(0 downto 0);
        clkdivtxi       : in     vl_logic_vector(0 downto 0);
        clklow          : out    vl_logic_vector(0 downto 0);
        clklowatti      : in     vl_logic_vector(0 downto 0);
        clklowi         : in     vl_logic_vector(0 downto 0);
        crurstbo        : out    vl_logic_vector(0 downto 0);
        dprioclk        : in     vl_logic_vector(0 downto 0);
        dprioclko       : out    vl_logic_vector(0 downto 0);
        dpriorstn       : in     vl_logic_vector(0 downto 0);
        dpriorstno      : out    vl_logic_vector(0 downto 0);
        earlyeios       : in     vl_logic_vector(0 downto 0);
        earlyeioso      : out    vl_logic_vector(0 downto 0);
        pldclk          : in     vl_logic_vector(0 downto 0);
        pldclko         : out    vl_logic_vector(0 downto 0);
        ppmlock         : in     vl_logic_vector(0 downto 0);
        ppmlocko        : out    vl_logic_vector(0 downto 0);
        rxdata          : out    vl_logic_vector(79 downto 0);
        rxdataatti      : in     vl_logic_vector(63 downto 0);
        rxdatacorei     : in     vl_logic_vector(79 downto 0);
        rxdatai         : in     vl_logic_vector(39 downto 0);
        rxdetclk        : in     vl_logic_vector(0 downto 0);
        rxdetclko       : out    vl_logic_vector(0 downto 0);
        rxdetectvalid   : out    vl_logic_vector(0 downto 0);
        rxdetectvalidi  : in     vl_logic_vector(0 downto 0);
        rxfound         : out    vl_logic_vector(0 downto 0);
        rxfoundi        : in     vl_logic_vector(0 downto 0);
        rxqpipulldn     : in     vl_logic_vector(0 downto 0);
        rxqpipulldno    : out    vl_logic_vector(0 downto 0);
        rxplllock       : out    vl_logic_vector(0 downto 0);
        rxplllockatti   : in     vl_logic_vector(0 downto 0);
        rxplllocki      : in     vl_logic_vector(0 downto 0);
        rxpmarstb       : in     vl_logic_vector(0 downto 0);
        rxpmarstbo      : out    vl_logic_vector(0 downto 0);
        slpbko          : out    vl_logic_vector(0 downto 0);
        sd              : out    vl_logic_vector(0 downto 0);
        sdi             : in     vl_logic_vector(0 downto 0);
        sershiftload    : in     vl_logic_vector(0 downto 0);
        sershiftloado   : out    vl_logic_vector(0 downto 0);
        signalok        : out    vl_logic_vector(0 downto 0);
        testbus         : out    vl_logic_vector(7 downto 0);
        testbusi        : in     vl_logic_vector(7 downto 0);
        testsel         : in     vl_logic_vector(3 downto 0);
        testselo        : out    vl_logic_vector(3 downto 0);
        txdata          : in     vl_logic_vector(79 downto 0);
        txdatao         : out    vl_logic_vector(79 downto 0);
        txelecidle      : in     vl_logic_vector(0 downto 0);
        txelecidleo     : out    vl_logic_vector(0 downto 0);
        txpmasyncp      : in     vl_logic_vector(0 downto 0);
        txpmasyncpo     : out    vl_logic_vector(0 downto 0);
        txqpipulldn     : in     vl_logic_vector(0 downto 0);
        txqpipulldno    : out    vl_logic_vector(0 downto 0);
        txqpipullup     : in     vl_logic_vector(0 downto 0);
        txqpipullupo    : out    vl_logic_vector(0 downto 0);
        txdetectrx      : in     vl_logic_vector(0 downto 0);
        txdetectrxo     : out    vl_logic_vector(0 downto 0);
        txpmarstbo      : out    vl_logic_vector(0 downto 0);
        avmmrstn        : in     vl_logic_vector(0 downto 0);
        avmmclk         : in     vl_logic_vector(0 downto 0);
        avmmwrite       : in     vl_logic_vector(0 downto 0);
        avmmread        : in     vl_logic_vector(0 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic_vector(0 downto 0)
    );
end stratixv_hssi_pma_int;
