library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_pma_rx_buf is
    generic(
        enable_debug_info: string  := "false";
        channel_number  : integer := 0;
        eq_bw_sel       : string  := "bw_full_12p5";
        input_vcm_sel   : string  := "high_vcm";
        pdb_sd          : string  := "false";
        qpi_enable      : string  := "false";
        rx_dc_gain      : integer := 0;
        rx_sel_bias_source: string  := "bias_vcmdrv";
        sd_off          : integer := 0;
        sd_on           : integer := 0;
        sd_threshold    : integer := 0;
        serial_loopback : string  := "lpbkp_dis";
        term_sel        : string  := "int_100ohm";
        vccela_supply_voltage: string  := "vccela_1p0v";
        avmm_group_channel_index: integer := 0;
        use_default_base_address: string  := "true";
        user_base_address: integer := 0;
        bypass_eqz_stages_234: string  := "all_stages_enabled";
        cdrclk_to_cgb   : string  := "cdrclk_2cgb_dis";
        diagnostic_loopback: string  := "diag_lpbk_off";
        pmos_gain_peak  : string  := "eqzp_en_peaking";
        vcm_current_add : string  := "vcm_current_default";
        vcm_sel         : string  := "vtt_0p70v";
        cdr_clock_enable: string  := "true";
        ct_equalizer_setting: integer := 1;
        enable_rx_gainctrl_pciemode: string  := "false"
    );
    port(
        voplp           : in     vl_logic_vector(0 downto 0);
        vonlp           : in     vl_logic_vector(0 downto 0);
        dataout         : out    vl_logic_vector(0 downto 0);
        ck0sigdet       : in     vl_logic_vector(0 downto 0);
        lpbkp           : in     vl_logic_vector(0 downto 0);
        rstn            : in     vl_logic_vector(0 downto 0);
        hardoccalen     : in     vl_logic_vector(0 downto 0);
        datain          : in     vl_logic_vector(0 downto 0);
        slpbk           : in     vl_logic_vector(0 downto 0);
        rxqpipulldn     : in     vl_logic_vector(0 downto 0);
        rdlpbkp         : out    vl_logic_vector(0 downto 0);
        sd              : out    vl_logic_vector(0 downto 0);
        nonuserfrompmaux: in     vl_logic_vector(0 downto 0);
        adaptcapture    : in     vl_logic_vector(0 downto 0);
        adaptdone       : out    vl_logic_vector(0 downto 0);
        adcestandby     : in     vl_logic_vector(0 downto 0);
        hardoccaldone   : out    vl_logic_vector(0 downto 0);
        eyemonitor      : in     vl_logic_vector(4 downto 0);
        lpbkn           : in     vl_logic_vector(0 downto 0);
        rxrefclk        : out    vl_logic_vector(0 downto 0);
        rdlpbkn         : out    vl_logic_vector(0 downto 0);
        avmmrstn        : in     vl_logic_vector(0 downto 0);
        avmmclk         : in     vl_logic_vector(0 downto 0);
        avmmwrite       : in     vl_logic_vector(0 downto 0);
        avmmread        : in     vl_logic_vector(0 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic_vector(0 downto 0)
    );
end stratixv_hssi_pma_rx_buf;
