library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_pma_tx_buf is
    generic(
        enable_debug_info: string  := "false";
        avmm_group_channel_index: integer := 0;
        use_default_base_address: string  := "true";
        user_base_address: integer := 0;
        pre_emp_switching_ctrl_1st_post_tap: integer := 0;
        pre_emp_switching_ctrl_2nd_post_tap: integer := 0;
        pre_emp_switching_ctrl_pre_tap: integer := 0;
        qpi_en          : string  := "false";
        rx_det          : integer := 0;
        rx_det_pdb      : string  := "true";
        sig_inv_2nd_tap : string  := "false";
        sig_inv_pre_tap : string  := "false";
        term_sel        : string  := "int_100ohm";
        vod_switching_ctrl_main_tap: integer := 0;
        channel_number  : integer := 0;
        dft_sel         : string  := "disabled";
        common_mode_driver_sel: string  := "volt_0p65v";
        driver_resolution_ctrl: string  := "disabled";
        local_ib_ctl    : string  := "ib_29ohm";
        rx_det_output_sel: string  := "rx_det_pcie_out";
        slew_rate_ctrl  : integer := 1;
        swing_boost     : string  := "not_boost";
        vcm_ctrl_sel    : string  := "ram_ctl";
        vcm_current_addl: string  := "vcm_current_default";
        vod_boost       : string  := "not_boost";
        fir_coeff_ctrl_sel: string  := "ram_ctl"
    );
    port(
        nonuserfrompmaux: in     vl_logic_vector(0 downto 0);
        rxdetclk        : in     vl_logic_vector(0 downto 0);
        txdetrx         : in     vl_logic_vector(0 downto 0);
        txelecidl       : in     vl_logic_vector(0 downto 0);
        datain          : in     vl_logic_vector(0 downto 0);
        txqpipullup     : in     vl_logic_vector(0 downto 0);
        txqpipulldn     : in     vl_logic_vector(0 downto 0);
        fixedclkout     : out    vl_logic_vector(0 downto 0);
        rxdetectvalid   : out    vl_logic_vector(0 downto 0);
        rxfound         : out    vl_logic_vector(0 downto 0);
        dataout         : out    vl_logic_vector(0 downto 0);
        vrlpbkn         : in     vl_logic_vector(0 downto 0);
        vrlpbkp         : in     vl_logic_vector(0 downto 0);
        vrlpbkp1t       : in     vl_logic_vector(0 downto 0);
        vrlpbkn1t       : in     vl_logic_vector(0 downto 0);
        icoeff          : in     vl_logic_vector(17 downto 0);
        avmmrstn        : in     vl_logic_vector(0 downto 0);
        avmmclk         : in     vl_logic_vector(0 downto 0);
        avmmwrite       : in     vl_logic_vector(0 downto 0);
        avmmread        : in     vl_logic_vector(0 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic_vector(0 downto 0)
    );
end stratixv_hssi_pma_tx_buf;
