library verilog;
use verilog.vl_types.all;
entity stratixv_hssi_rx_pcs_pma_interface is
    generic(
        enable_debug_info: string  := "false";
        selectpcs       : string  := "eight_g_pcs";
        clkslip_sel     : string  := "pld";
        prot_mode       : string  := "other_protocols";
        avmm_group_channel_index: integer := 0;
        use_default_base_address: string  := "true";
        user_base_address: integer := 0
    );
    port(
        clockinfrompma  : in     vl_logic_vector(0 downto 0);
        datainfrompma   : in     vl_logic_vector(79 downto 0);
        pmasigdet       : in     vl_logic_vector(0 downto 0);
        pmarxclkslip    : out    vl_logic_vector(0 downto 0);
        pmasignalok     : in     vl_logic_vector(0 downto 0);
        pmarxclkout     : out    vl_logic_vector(0 downto 0);
        clkoutto10gpcs  : out    vl_logic_vector(0 downto 0);
        dataoutto10gpcs : out    vl_logic_vector(79 downto 0);
        pcs10gsignalok  : out    vl_logic_vector(0 downto 0);
        pcs10grxclkiqout: in     vl_logic_vector(0 downto 0);
        clockouttogen3pcs: out    vl_logic_vector(0 downto 0);
        dataouttogen3pcs: out    vl_logic_vector(31 downto 0);
        pcsgen3pmasignaldet: out    vl_logic_vector(0 downto 0);
        pcs8grxclkiqout : in     vl_logic_vector(0 downto 0);
        pcs8grxclkslip  : in     vl_logic_vector(0 downto 0);
        clockoutto8gpcs : out    vl_logic_vector(0 downto 0);
        dataoutto8gpcs  : out    vl_logic_vector(19 downto 0);
        pcs8gsigdetni   : out    vl_logic_vector(0 downto 0);
        pmaclkdiv33txorrxin: in     vl_logic_vector(0 downto 0);
        pmaclkdiv33txorrxout: out    vl_logic_vector(0 downto 0);
        pcs10gclkdiv33txorrx: out    vl_logic_vector(0 downto 0);
        pmarxpmarstb    : out    vl_logic_vector(0 downto 0);
        pldrxpmarstb    : in     vl_logic_vector(0 downto 0);
        pldrxclkslip    : in     vl_logic_vector(0 downto 0);
        asynchdatain    : out    vl_logic_vector(0 downto 0);
        reset           : out    vl_logic_vector(0 downto 0);
        pcsgen3eyemonitorin: out    vl_logic_vector(1 downto 0);
        pmaeyemonitorin : in     vl_logic_vector(1 downto 0);
        pmarxpllphaselockout: out    vl_logic_vector(0 downto 0);
        pcsgen3eyemonitorout: in     vl_logic_vector(7 downto 0);
        pmarxpllphaselockin: in     vl_logic_vector(0 downto 0);
        pmareservedout  : out    vl_logic_vector(4 downto 0);
        pmaeyemonitorout: out    vl_logic_vector(7 downto 0);
        pcsemsiprxclkiqout: in     vl_logic_vector(0 downto 0);
        pmareservedin   : in     vl_logic_vector(4 downto 0);
        avmmrstn        : in     vl_logic_vector(0 downto 0);
        avmmclk         : in     vl_logic_vector(0 downto 0);
        avmmwrite       : in     vl_logic_vector(0 downto 0);
        avmmread        : in     vl_logic_vector(0 downto 0);
        avmmbyteen      : in     vl_logic_vector(1 downto 0);
        avmmaddress     : in     vl_logic_vector(10 downto 0);
        avmmwritedata   : in     vl_logic_vector(15 downto 0);
        avmmreaddata    : out    vl_logic_vector(15 downto 0);
        blockselect     : out    vl_logic_vector(0 downto 0)
    );
end stratixv_hssi_rx_pcs_pma_interface;
