//---------------------------------------------------------------------
// This module instantiates datagen_16bit_x1. for 4 lanes. 
// datagen_16bit_x1.v generates 16-bit data based on the controls 
// received form datagen_ctrl_top.v
//---------------------------------------------------------------------
`timescale 1ns/100ps

module syncgen_16bit_4lanes
(
  clk,              
  reset, 
  xmit_TS1,           
  input_data_size,
  data_out_l1,      
  data_out_l2, 
  data_out_l3,
  data_out_l4
);

input clk, reset, xmit_TS1;            
input[11:0] input_data_size; 

      
output[17:0] data_out_l1;         
output[17:0] data_out_l2;         
output[17:0] data_out_l3;         
output[17:0] data_out_l4;         



wire[2:0] lane_id_l1 = 3'b000;
wire[2:0] lane_id_l2 = 3'b001;
wire[2:0] lane_id_l3 = 3'b010;
wire[2:0] lane_id_l4 = 3'b011;


syncgen_16bit_1lane p1 (
 .clk                (clk),
 .reset              (reset),
 .lane_id            (lane_id_l1),   
 .input_data_size    (input_data_size),
 .xmit_TS1           (xmit_TS1),  
 .data_out           (data_out_l1)
 );

syncgen_16bit_1lane p2 (
 .clk                (clk),
 .reset              (reset),
 .lane_id            (lane_id_l2),   
 .input_data_size    (input_data_size),
 .xmit_TS1           (xmit_TS1),
 .data_out           (data_out_l2)
);


syncgen_16bit_1lane p3 (
 .clk                (clk),
 .reset              (reset),
 .lane_id            (lane_id_l3),   
 .input_data_size    (input_data_size),
 .xmit_TS1           (xmit_TS1) ,  
 .data_out           (data_out_l3)
);

syncgen_16bit_1lane p4 (
 .clk                (clk),
 .reset              (reset),
 .lane_id            (lane_id_l4),   
 .input_data_size    (input_data_size),
 .xmit_TS1           (xmit_TS1) ,  
 .data_out           (data_out_l4) 
);

endmodule
