library verilog;
use verilog.vl_types.all;
entity top is
    generic(
        ROM_DEPTH       : integer := 512;
        PIO_OUT_SIZE    : integer := 16;
        PIO_IN_SIZE     : integer := 32;
        CLK_PERIOD_IN_PS: integer := 10000
    );
    port(
        pll_ref_clk     : in     vl_logic;
        clk150          : in     vl_logic;
        reset           : in     vl_logic;
        rx_serial_data1 : in     vl_logic;
        rx_serial_data2 : in     vl_logic;
        tx_clkout1      : out    vl_logic;
        tx_clkout2      : out    vl_logic;
        rx_clkout1      : out    vl_logic;
        rx_clkout2      : out    vl_logic;
        tx_ready        : out    vl_logic;
        tx_serial_data1 : out    vl_logic;
        tx_serial_data2 : out    vl_logic;
        rx_ready        : out    vl_logic;
        reconfig_busy   : out    vl_logic;
        init_phase      : out    vl_logic;
        data_phase      : out    vl_logic;
        ready_for_mgmt_and_reconfig: out    vl_logic;
        rx_syncstatus_read1: out    vl_logic_vector(1 downto 0);
        rx_syncstatus_read2: out    vl_logic_vector(1 downto 0);
        pio_out         : out    vl_logic_vector(15 downto 0);
        prbs_checker_lock: out    vl_logic;
        prbs_checker_errorFlag: out    vl_logic
    );
end top;
